//------------------------------------------------------------------------------
// fwkBrowser.js 
//------------------------------------------------------------------------------
// Version : 1.0 ( 26/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------
function Browser()
{
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------
	this.NAV_NULL = 0 ;
	this.NAV_MOZILLA_FIREFOX   = 1 ; 
	this.NAV_INTERNET_EXPLORER = 2 ;

	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	this.iBrowserType = this.NAV_NULL ;
	
	
	//------------------------------------------------------------------------------
	// INITIALIZATIONS
	//------------------------------------------------------------------------------
	{
		//var sNavigName = navigator.appName ;
		if ( navigator.appName.indexOf("Netscape") >= 0 )
		{
			this.iBrowserType = this.NAV_MOZILLA_FIREFOX ;
		}
		else if ( navigator.appName.indexOf("Microsoft") >= 0 )
		{
			this.iBrowserType = this.NAV_INTERNET_EXPLORER ;
		}
	}

	//------------------------------------------------------------------------------
	// METHODS
	//------------------------------------------------------------------------------
	this.isMozilla = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_MOZILLA_FIREFOX ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.isInternetExplorer = function() // BOOLEAN
	{
		return ( this.iBrowserType == this.NAV_INTERNET_EXPLORER ? true : false ) ;
	}
	//------------------------------------------------------------------------------
	this.getType = function() // STRING
	{
		switch ( this.iBrowserType )
		{
			case this.NAV_MOZILLA_FIREFOX :   return "Mozilla/Firefox" ;
			case this.NAV_INTERNET_EXPLORER : return "Internet Explorer" ;
		}
		return "???" ;
	}
	
}
//------------------------------------------------------------------------------
// Static properties
//------------------------------------------------------------------------------
Browser.browser = new Browser() ; 
//------------------------------------------------------------------------------
// Static methods
//------------------------------------------------------------------------------
Browser.getBrowser = function ()
{
	return Browser.browser ;
}
//------------------------------------------------------------------------------

