//------------------------------------------------------------------------------
// ScreenField.js
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
function ScreenField(argFieldId, argFieldObject, argScreenZone, argXmlTag, argXmlAttr)
{
	//alert("ScreenField("+argFieldId+", ... ,"+ argScreenZone+","+ argXmlTag+","+ argXmlAttr+")" );
	if ( argFieldId == null )
	{
		throw new Error("ScreenField constructor : Field ID is null" );
		//alert ( "ERROR : ScreenField constructor : Field ID is null !" );
	}
	if ( argFieldObject == null )
	{
		throw new Error("ScreenField constructor : Unknown field with ID = " + argFieldId );
		//alert ( "ERROR : ScreenField constructor : Unknown field with ID = " + this.sId  );
	}

	//==============================================================================
	// PUBLIC ATTRIBUTES
	//==============================================================================
	this.sId      = argFieldId ; // cannot be null 
	this.oField   = argFieldObject; // cannot be null 
	this.sZone    = argScreenZone ;
	this.sXmlTag  = argXmlTag ; // can be null (if no XML mapping)
	this.sXmlAttr = argXmlAttr ; // can be null (if no XML mapping)
}
