//----------------------------------------------------------------------------------------------------
// getWithParams.js
//----------------------------------------------------------------------------------------------------
function doGetWithParams(params)
{
	//-----------------------------------------------------------------------------------------------
	// Inner function to process the response
	//-----------------------------------------------------------------------------------------------
	function afterGetWithParams(oResponse)
	{
		//alert ( "afterGetWithParams()...");
		if ( oResponse != null )
		{
			if ( oResponse.isOK() )
			{
				if ( oResponse.dataVoid() != true ) // Data is not void
				{
					//alert ( "OK : data not void" );
					//--- Populate the screen fields with XML data recieved
					var currentScreen = actions.getScreen();
					if ( currentScreen != null )
					{
						//alert ( "XmlToScreen" );
						currentScreen.XmlToScreen(oResponse);
					}
					else
					{
						alert ( "ERROR : No current screen in 'actions' object !" );
					}
				}
			}
			else
			{
				alert ( "ERROR : Response error !" );
			}			
		}
		else
		{
			alert ( "ERROR : No response object !" );
		}
	}
	//-----------------------------------------------------------------------------------------------
	// GET request
	//-----------------------------------------------------------------------------------------------
	//alert ( "doGetWithParams() ...");
	try {
		//--- Build the request 
		var request = actions.getRequest("get") ; 
		//--- Set the parameters 
		if ( params != null )
		{
			for ( p in params )
			{
				request.setParameter(p, params[p] );
			}
		}
		//--- Send the request ( callback -> inner function )
		actions.sendRequestAsync(request,afterGetWithParams); 		
	}
	catch (ex) {
		alert ( "ERROR " + ex.message );
	}
}
//----------------------------------------------------------------------------------------------------