//------------------------------------------------------------------------------
// fwkListDetail.js
//------------------------------------------------------------------------------
// Uses : none
//------------------------------------------------------------------------------
// Version : 1.2  ( 11/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------
// Le flux rcupr commence par le niveau <tbody> ... 0  N lignes </tbody>
// Il est affect en tant que "innerHtml" de la DIV qui contient la liste
// innerHtml = "..." ne fonctionne pas sur <TBody> ( mais OK sur <div> et sur <td> )
// => ncessite de recomposer le contenu par  "<div><table>" + FLUX + "</table></div>"
//------------------------------------------------------------------------------

function isNavNetscape()
{
   if ( navigator.appName.indexOf("Netscape") >= 0 )  return true ;
   else return false ;
}
function isNavMicrosoft()
{
   if ( navigator.appName.indexOf("Microsoft") >= 0 )  return true ;
   else return false ;
}

//------------------------------------------------------------------------------
// OBJECT "ListDetail"
//------------------------------------------------------------------------------
//function ListDetail( sDivListId, sDivDetailId, sRowTemplateId )
function ListDetail( sDivListId, sDivDetailId )
{
	// alert ( "Constructor ( " + sDivListId + ", " + sDivDetailId + " ) " );
	var sErrMsg = "ERROR: ListDetail() constructor : " ;
	if ( sDivListId   == null ) alert ( sErrMsg + "1st argument is null ( sDivListId )" ) ;
	if ( sDivDetailId == null ) alert ( sErrMsg + "2nd argument is null ( sDivDetailId )" ) ;
	
	//------------------------------------------------------------------------------
	// ATTRIBUTS
	//------------------------------------------------------------------------------
	this._currentLineTR     = null ;
	this._currentLineDIV    = null ;
	this._aDetailFields     = new Array() ; // Tableau des champs de la "zone detail"
	this._sSerializedFields = "" ;
	this._oDivList          = null ;
	this._oTableList        = null ;
	this._oTBodyList        = null ;
	// this._oTFootList        = null ;
	// this._oTemplateTD       = null ;
	this._oTemplateTR       = null ; 

	this._sRowTemplate    = null ;  // Void Row Cell <td>...</td>
	
	this._oDivDetail        = null ;
	this._sColorSelected    = "blue" ;
	this._sColorNormal      = "#DDDDDD" ;
	this._sPostFormId       = "formToPost" ;
	this._sPostTextId       = "textToPost" ;
	this._oRequester        = null ; // HTTP Requester 
	
	this._sDivListId = sDivListId ;
	
	
	//------------------------------------------------------------------------------
	// METHODES D'INITIALISATION
	//------------------------------------------------------------------------------
	// Initialisation de tous les champs avec "FieldName" contenus dans le container "DETAIL" 
	this.initDetailFields = function(oElement)  // Traitement rcursif des Elements "enfants" d'un Element
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						//--- Ajout du champ associ  son nom
						this._aDetailFields[sFieldName] = oChild ; 
					}
				/**
					alert ( "oChild : " 
					+ "\n id = " + oChild.id 
					+ "\n tagName  = " + oChild.tagName 
					+ "\n nodeName = " + oChild.nodeName
					+ "\n nodeType = " + oChild.nodeType 
					+ "\n localName = " + oChild.localName 
					+ "\n FieldName = " + sFieldName ) ;
				**/
				}
				
				//--- Enfants (par rcursivit)
				this.initDetailFields(oChild) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	this.showDetailFields = function()  
	{
		var s = "" ;
		for ( key in this._aDetailFields )
		{
			s = s + key + " : " + this._aDetailFields[key] + "\n" ;
		}
		alert ( "this._aDetailFields : \n" + s ) ; 
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.initStructure = function() 
	{
//--- LIST CONTAINER 
if ( this._sDivListId == null )
{
	alert ( "initStructure() : no DIV id for the list container ! ") ; 	
}
else
{
	//--- Container "DIV" de la liste
	this._oDivList = document.getElementById(this._sDivListId);
	if ( this._oDivList == null ) 
	{ 
		alert ( "initStructure() : cannot found DIV with id = " + this._sDivListId ) ; 
	}
	else
	{
		alert ( "initStructure() : _oDivList set.  Div Id = " + this._sDivListId ) ; 
	}
}
	
		if ( this._oDivList == null ) 
		{ 
			alert ( "ERROR: DIV LIST is null !" ) ; 
		}
		else
		{
			//--- Premier lment "TABLE" enfant de "DIV"
			this._oTableList = this._oDivList.getElementsByTagName("table")[0] ; 
			if ( this._oTableList == null ) 
			{ 
				alert ( "cannot found TABLE for DIV LIST " ) ; 
			}
			else
			{
				//--- Premier lment "TBODY" enfant de "TABLE"
				this._oTBodyList = this._oTableList.getElementsByTagName("tbody")[0] ; 
				if ( this._oTBodyList == null ) 
				{ 
					alert ( "cannot found TBODY for TABLE in DIV LIST " ) ; 
				}
		/*****
				//--- Premier lment "TFOOT" enfant de "TABLE"
				this._oTFootList = this._oTableList.getElementsByTagName("tfoot")[0] ; 
				if ( this._oTFootList == null ) 
				{ 
					alert ( "cannot found TFOOT for TABLE in DIV LIST " ) ; 
				}
				else
				{
					//--- Template ( TABLE/TFOOT/TR) : premier lment "TR" enfant de "TFOOT" 
					this._oTemplateTR = this._oTFootList.getElementsByTagName("tr")[0] ;
					if ( this._oTemplateTR == null ) 
					{ 
						alert ( "cannot found <TR> TEMPLATE in DIV LIST  "  ) ; 
					}
					//--- Template ( TABLE/TFOOT/TR/TD ) : premier lment "TD" enfant de "TFOOT" 
					this._oTemplateTD = this._oTFootList.getElementsByTagName("td")[0] ;
					if ( this._oTemplateTD == null ) 
					{ 
						alert ( "cannot found <TD> TEMPLATE in DIV LIST "  ) ; 
					}
				}
		*****/
			}
		}
		alert("End of initStructure : TBody.rows.length = " + this._oTBodyList.rows.length ) ;
	}
		
	//------------------------------------------------------------------------------
	// PSEUDO "CONSTRUCTEUR" ( INITIALISATIONS )
	//------------------------------------------------------------------------------
	{
		//--- HTTP REQUESTER
		if (window.ActiveXObject) 
		{
			//--- I.E.
			this._oRequester = new ActiveXObject("Microsoft.XMLHTTP") ;
		}
		else if (window.XMLHttpRequest)
		{
			//--- Mozilla
			this._oRequester = new XMLHttpRequest();
		}
	
		//--- LIST CONTAINER 
		if ( this._sDivListId == null )
		{
			alert ( "Constructor : no DIV id for the list container ! ") ; 	
		}
		else
		{
			//--- Container "DIV" de la liste
			this._oDivList = document.getElementById(this._sDivListId);
			if ( this._oDivList == null ) 
			{ 
				alert ( "cannot found DIV with id = " + this._sDivListId ) ; 
			}
			else
			{
			}
		}
		//--- DETAIL CONTAINER 
		if ( sDivDetailId == null )
		{
			alert ( "Constructor : no DIV id for the detail container ! ") ; 	
		}
		else
		{
			//--- Container "DIV" de la partie "DETAIL"
			this._oDivDetail = document.getElementById( sDivDetailId );
			if ( this._oDivDetail == null ) 
			{ 
				alert ( "cannot found DIV with id = " + sDivDetailId ) ; 
			}
			this.initDetailFields(this._oDivDetail);
			//this.showDetailFields() ;
		}
/***
		//--- ROW TEMPLATE 
		if ( sRowTemplateId == null )
		{
			alert ( "Constructor : no id for the ROW TEMPLATE ! ") ; 	
		}
		else
		{
			//--- Container "DIV" de la partie "DETAIL"
			this._oTemplateTR = document.getElementById( sRowTemplateId );
			if ( this._oTemplateTR == null ) 
			{ 
				alert ( "cannot found ROW TEMPLATE with id = " + sRowTemplateId ) ; 
			}
		}
***/
		
		this.initStructure()
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
/****
	this.clearStructure = function() 
	{
		this._oTableList = null ;
		this._oTBodyList = null ;
		// this._oTFootList = null ;
		// this._oTemplateTR = null ;
		// this._oTemplateTD = null ;
	}
****/	

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.getResponseFromUrl = function( sURL )
	{
		alert ( "getResponseFromUrl"+ sURL + " )" ) ; 
		if ( this._oRequester == null )
		{
			alert ( "ERROR: Http requester is null ! \n Cannot send request. " );
			return ;
		}
		//--- Request to get data from the server
		this._oRequester.open("POST", sURL, false );
		//alert("After OPEN");
		this._oRequester.send(null);
		//alert("After SEND");

		return this._oRequester.responseText ;
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.setVoidTemplateFromUrl = function( sUrl ) 
	{
		alert("setVoidTemplateFromUrl("+sUrl+")");
		this._sRowTemplate = this.getResponseFromUrl ( sUrl ) ;
		alert("URL Response : \n" + this._sRowTemplate );
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.cancelEvent = function(evt) //--- Arrte la propagation de l'vnement 
	{
		if ( isNavMicrosoft() )
		{
			//--- Spcifique Internet Explorer
			window.event.cancelBubble = true;   
		}
		else if ( isNavNetscape() ) 
		{
			//--- Spcifique Mozilla / Netscape
			//alert ( "Navigateur is NETSCAPE");
			if ( evt == null ) 
			{
				alert ( "event is null ! " );
			}
			else
			{
				if ( evt.stopPropagation == null ) alert ( "stopPropagation is null ! ");
				else evt.stopPropagation();
			}
		}
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.getParentTR = function(object)
	{
		//--- Retourne l'objet 'TR' contenant l'objet pass en parametre
		//--- On remonte dans la hirarchie jusqu'a trouver un objet "TR" 
		var oNode = object.parentNode ;
		while ( oNode.tagName != "TR" )
		{
			oNode = oNode.parentNode ;
		}
		return oNode ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.showRowStatus = function(oTR)
	{
		if ( oTR != null )
		{
			//var key = oTR.getAttribute("key");
			window.status = oTR.rowIndex ; // + " ( key = " + key + " )" ;
		}
		else
		{
			window.status= "???" ;
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.changeCurrentLine = function(oTR,oDIV)
	{
		//alert("changeCurrentLine");
		if ( oTR == null )
		{
			alert ( "changeCurrentLine : oTR is null ! ") ;
			return ;
		}
		if ( oDIV == null )
		{
			alert ( "changeCurrentLine : oDIV is null ! ") ;
			return ;
		}
		
		this.beforeSelectRow(oTR,oDIV); //--- EVENEMENT (A SURCHARGER)
		if ( this._currentLineTR != null )
		{
			this.applyDetailToList() ;
		}
		if ( this._currentLineDIV != null )
		{
			this._currentLineDIV.style.backgroundColor = this._sColorNormal ; 
		}
		this._currentLineTR  = oTR ;
		this._currentLineDIV = oDIV ;
		this._currentLineDIV.style.backgroundColor = this._sColorSelected ;

		//--- Affichage des information de la nouvelle ligne courante 
		this.showRowStatus(oTR);
		this.showDetail(oTR); //--- Affichage de la partie "DETAIL" de la ligne
		this.afterSelectRow(oTR,oDIV); //--- EVENEMENT (A SURCHARGER)
	}
	//------------------------------------------------------------------------------
	// METHODE :  
	//------------------------------------------------------------------------------
	this.selectLineTR = function(oTR)
	{
		//--- Si la ligne est dj slectionne on ne fait rien 
		if ( oTR === this._currentLineTR ) return ; // Oprateur "STRICTEMENT EGAL"
		var oDIV = oTR.getElementsByTagName("div")[0] ; // Premier Tag DIV contenu dans TR
		this.changeCurrentLine(oTR, oDIV);
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectLineDIV = function(oDIV)
	{
		//--- Si la ligne est dj slectionne on ne fait rien 
		if ( oDIV === this._currentLineDIV ) return ; // Oprateur "STRICTEMENT EGAL"
		var oTR = this.getParentTR(oDIV); // Tag TR qui contient la DIV
		this.changeCurrentLine( oTR, oDIV );
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectLine = function(obj)
	{
		this.selectLineDIV( obj );
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.setColors = function(sNormal, sSelected)
	{
		this._sColorNormal      = sNormal ;
		this._sColorSelected    = sSelected ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectFirstLine = function()
	{
		//alert ( "selectFirstLine()" ) ;
		if ( this._oTBodyList != null )
		{
			if ( this._oTBodyList.rows.length > 0 ) this.selectLineTR(this._oTBodyList.rows[0]) ;
		}
		else
		{
			alert ( "selectFirstLine : object oTBodyList is null ! ") ;
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowUp = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowUp ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveUp : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
	
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex > 0 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex-1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex-1]);		
		}
		else
		{
			alert("On est au dbut !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowDown = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowDown ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveRowDown : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex < this._oTBodyList.rows.length-1 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex+1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex+1]);		
		}
		else
		{
			alert("On est  la fin !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.deleteRow = function(object) // NB nom "deleteRow" rserv sous Mozilla 
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//cancelEvent inutile la ligne est supprime => pas de propagation
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "deleteRow : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
	
		//alert ( "rowIndex to delete : " + oTR.rowIndex );
		var iRowIndexToDelete = oTR.rowIndex ;
		this._oTBodyList.deleteRow(iRowIndexToDelete);
		
		if ( this._oTBodyList.rows.length > 0 ) // Si il reste au moins une ligne
		{
			if ( iRowIndexToDelete < this._oTBodyList.rows.length )
			{
				this.selectLineTR( this._oTBodyList.rows[iRowIndexToDelete] );
			}
			else
			{
				this.selectLineTR( this._oTBodyList.rows [ this._oTBodyList.rows.length-1 ] ) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.insertBeforeRow = function(object, evt) // NB nom "deleteRow" rserv sous Mozilla 
	{
		if ( evt == null ) alert ( "evt is null ");
		this.cancelEvent(evt); // Cancel Event (vite Click -> Select Row)
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		//--- Insertion d'une nouvelle ligne (TR)
		//alert ( "rowIndex to insert : " + oTR.rowIndex );
		var oNewTR = this._oTBodyList.insertRow(oTR.rowIndex);	
	
		this.initAndSelectNewRow(oNewTR);
		
		//--- Slection de la nouvelle ligne 
		//this.selectLineTR(oNewTR);		
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.addRow = function()  
	{
// ### PROVISOIRE 
		this.addRow2(); 
		return;
// ### PROVISOIRE 
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( "addRow : " + sTBodyId );
		//var oTBODY = document.getElementById(sTBodyId);
		//if ( oTBODY == null ) { alert ( "oTBODY is null ! " ) ; return ; }
	
		//--- Insertion d'une nouvelle ligne (TR)
		//alert ( "rowIndex to insert : " + oTR.rowIndex );
		if ( this._oTBodyList == null )
		{
			alert ( "ERROR: Liste table : TBody is null ! " );
			return ;
		}
		alert("rows.length = " + this._oTBodyList.rows.length);
		var oNewTR = this._oTBodyList.insertRow(this._oTBodyList.rows.length); // Ok / IE & Mozilla
		this.initAndSelectNewRow(oNewTR);
		//this.selectLineTR(oNewTR);
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.initAndSelectNewRow = function(oNewTR)  
	{	
// ### PROVISOIRE 
		this.initAndSelectNewRow2(oNewTR); 
		return;
// ### PROVISOIRE 
		
		//----------------------------------------------------------------------
		// Application du Template  la nouvelle ligne 
		//----------------------------------------------------------------------
	/***
		//--- Cration d'une cellule "TD" dans cette nouvelle ligne 
		var oNewTD    = oNewTR.insertCell(0); // Ok / IE & Mozilla
		oNewTD.height = this._oTemplateTD.height; // Hauteur identique  celle du Template
		//--- Copie du contenu HTML de la cellule template dans la nouvelle cellule 
		oNewTD.innerHTML = this._oTemplateTD.innerHTML;
	***/
		if ( this._oTemplateTR == null )
		{
			alert ( "ERROR: initAndSelectNewRow() : _oTemplateTR is null ! " );
			return;
		}
		//alert ( "TR inner html = " + this._oTemplateTR.innerHTML ); 
		if ( isNavMicrosoft() )
		{
			//--- With Microsoft I.E. : use clode/replace Node
			var oClone = this._oTemplateTR.cloneNode(true);
			//alert ("after cloneNode");
			oNewTR.replaceNode(oClone);
			//alert ("after replaceNode");
/*****
			if ( oClone.hasChildNodes() )
			{
				alert("TR has child nodes" );
			}
			else
			{
				alert("TR has NO child nodes" );
			}
			var oNewTD  = oClone.getElementsByTagName("td")[0] ;
			if ( oNewTD != null  )
			{
				alert("TR has TD " );
			}
			else
			{
				alert("TR has NO TD" );
			}
			var oNewDiv = oClone.getElementsByTagName("div")[0] ;
			if ( oNewDiv != null )
			{
				alert("TR has DIV " );
			}
			else
			{
				alert("TR has NO DIV" );
			}
*****/
			//--- Select the new line = the CLONE that replace the TR created
			this.selectLineTR(oClone);	
		}
		else
		{
			alert ( "template HTML : \n" + this._oTemplateTR.innerHTML ) ;
			//--- With Mozilla/Firefox : use innerHTML
			oNewTR.innerHTML = this._oTemplateTR.innerHTML ; // Impossible sous IE (Error JS)
			//--- Select the new line = the TR created
			this.selectLineTR(oNewTR);	
		}
	}
	//------------------------------------------------------------------------------
	this.initAndSelectNewRow2 = function(oNewTR)  
	{	
		if ( this._oTemplateTR == null )
		{
			alert ( "ERROR: initAndSelectNewRow() : _oTemplateTR is null ! " );
			return;
		}
		if ( oNewTR.insertCell )
		{
			alert ( "inserting cell" );
		}
		var oTD = oNewTR.insertCell(0);
		var oDivTemplate = document.getElementById("xTemplate" );
		if ( oDivTemplate == null )
		{
			alert ("Template NOT FOUND !");
		}
		alert ("set innerHTML :\n"+ oDivTemplate.innerHTML );
		oTD.innerHTML = oDivTemplate.innerHTML ;
/***
		//alert ( "TR inner html = " + this._oTemplateTR.innerHTML ); 
		if ( isNavMicrosoft() )
		{
			//--- With Microsoft I.E. : use clode/replace Node
			var oClone = this._oTemplateTR.cloneNode(true);
			//alert ("after cloneNode");
			oNewTR.replaceNode(oClone);
			//alert ("after replaceNode");
			//--- Select the new line = the CLONE that replace the TR created
			this.selectLineTR(oClone);	
		}
		else
		{
			alert ( "template HTML : \n" + this._oTemplateTR.innerHTML ) ;
			//--- With Mozilla/Firefox : use innerHTML
			oNewTR.innerHTML = this._oTemplateTR.innerHTML ; // Impossible sous IE (Error JS)
			//--- Select the new line = the TR created
			this.selectLineTR(oNewTR);	
		}
***/
	}
	//------------------------------------------------------------------------------
	this.getListTable = function()  
	{	
		if ( this._oDivList == null )
		{
			alert("ERROR: getListTBody() : Div List is NULL !");
		}
		else
		{
			//--- Premier lment "TABLE" enfant de "DIV"
			return this._oDivList.getElementsByTagName("table")[0] ; 
		}
	}	
	//------------------------------------------------------------------------------
	this.getListTBody = function()  
	{	
		if ( this._oDivList == null )
		{
			alert("ERROR: getListTBody() : Div List is NULL !");
		}
		else
		{
			//--- Premier lment "TABLE" enfant de "DIV"
			var oTableList = this._oDivList.getElementsByTagName("table")[0] ; 
			if ( oTableList == null ) 
			{ 
				return null ;
			}
			//--- Premier lment "TBODY" enfant de "TABLE"
			return oTableList.getElementsByTagName("tbody")[0] ; 
		}
	}	
	//------------------------------------------------------------------------------
	this.listIsVoid = function()  
	{	
		if ( this._oTBodyList == null )
		{
			alert ( "Liste table : TBody is null => Set TABLE TEMPLATE" );
			return true ;
		}
		if ( this._oTBodyList.rows == null  ) 
		{
			alert ( "Liste table : TBody.rows is null => Set TABLE TEMPLATE" );
			return true ;
		}
		if ( this._oTBodyList.rows.length == 0 ) 
		{
			alert ( "Liste table : TBody.rows.length == 0 => Set TABLE TEMPLATE" );
			return true ;
		}
		return false ;
	}
	//------------------------------------------------------------------------------
	this.addRow2 = function()  
	{	
		alert ( "addRow2" );
		if ( this.listIsVoid() )
		{
			//--- Initialize the list content with a single row table 
			this.setListContentFromHtml(this._sRowTemplate);
		}
		else
		{
			//---------- IF THE LIST IS NOT VOID ----------
			alert("rows.length = " + this._oTBodyList.rows.length);
			//--- ROW creation ( <tr> ) 
			var oNewTR = this._oTBodyList.insertRow(this._oTBodyList.rows.length); // Ok / IE & Mozilla
			//--- CELL creation ( <td> ) 
			if ( oNewTR.insertCell )
			{
				alert ( "inserting cell" );
			}
			var oTD = oNewTR.insertCell(0);

			//var s1 = "<div id='fwkDivData' ><table border='0' cellpadding='0' cellspacing='0' width='100%'><tbody><tr>"
			//var s2 = "</tr></tbody></table></div>"
			alert ( "Set TD innerHTML : \n" + this._sRowTemplate );
			oTD.innerHTML = this._sRowTemplate ;
			
			/****
			if ( this._oTemplateTR == null )
			{
				alert ( "ERROR: initAndSelectNewRow() : _oTemplateTR is null ! " );
				return;
			}
			var oDivTemplate = document.getElementById("xTemplate" );
			if ( oDivTemplate == null )
			{
				alert ("Template NOT FOUND !");
			}
			alert ("set innerHTML :\n"+ oDivTemplate.innerHTML );
			oTD.innerHTML = oDivTemplate.innerHTML ;
			****/
		}
	}
		
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.showDetail = function(oElement) // oElement = "<TR>" 
	{
		if ( oElement == null ) { alert ( "showDetail : oElement is null ! ") ; return ; }
		this.applyListToDetail(oElement);
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	// Pour chaque "Field" de la ligne (ou des ses lments enfant) rcupration du champ correspondant 
	// dans la zone dtail ( via le tableau des champs de la zone dtail )
	// Association du "champ ligne" au "champ dtail" ( en vue du "applyDetailToList" )
	// Valorisation du "champ dtail"
	//------------------------------------------------------------------------------
	this.applyListToDetail = function(oElement) 
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var bField = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				bField     = null ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						var oDetailField = this._aDetailFields[sFieldName] ;
						if ( oDetailField != null )
						{
							//alert ( "set field value : " + oChild.value ) ;
							oDetailField.listField = oChild ;
							var sType = oDetailField.getAttribute("type") ;
						/***
							if ( sType == "radio" ) // TODO (a valider)
							{
	        						if ( DetailField.value == oChild.value ) 
	        							oDetailField.checked = true ;
	        						else
	        							oDetailField.checked = false ;								
							}
							else 
						***/
							if ( sType == "checkbox" )
							{
	        						if ( oChild.value == "1" ) 
	        							oDetailField.checked = true ;
	        						else
	        							oDetailField.checked = false ;								
							}
							else
							{
								oDetailField.value = oChild.value ;
							}
						}
						else
						{
							/* Ce n'est pas une erreur tous les champs ne figurent pas forcment dans le dtail
							alert ( "cannot found field  : " + sFieldName 
								+ " in _aDetailFields[]"  ) ;
							*/
						}
					}
	/***
					alert ( "applyListToDetail  oChild : " 
					+ "\n id = " + oChild.id 
					+ "\n tagName  = " + oChild.tagName 
					+ "\n nodeName = " + oChild.nodeName
					+ "\n nodeType = " + oChild.nodeType 
					+ "\n localName = " + oChild.localName 
					+ "\n FieldName = " + sFieldName 
					+ "\n detailField = " + bField ) ;
	***/
				}
				
				//--- Enfants (par rcursivit)
				this.applyListToDetail(oChild) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.clearDetail = function() 
	{
		var oDetailField = null ;
		for ( key in this._aDetailFields )
		{
			//alert ( "applyDetailToList : field " + key );
			oDetailField = this._aDetailFields[key] ;
			if ( oDetailField != null )
			{
				var sType = oDetailField.getAttribute("type") ;
				/***
				if ( sType == "radio" ) // TODO (a valider)
				{
					if ( oDetailField.checked ) // Radio Button "checked"
						oDetailField.listField.value = oDetailField.value ;
				}
				else
				***/ 
				if ( sType == "checkbox"  || sType == "radio" )
				{
					oDetailField.checked = false ;
				}
				else
				{
					oDetailField.value = "" ;
				}
			}
			else
			{
				alert ( "Field '"+key+"' not found !");
			}
		}
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.applyDetailToList = function() 
	{
		var oDetailField = null ;
		for ( key in this._aDetailFields )
		{
			//alert ( "applyDetailToList : field " + key );
			oDetailField = this._aDetailFields[key] ;
			if ( oDetailField != null )
			{
				if ( oDetailField.listField != null )
				{
					var sType = oDetailField.getAttribute("type") ;
					/***
					if ( sType == "radio" ) // TODO (a valider)
					{
						if ( oDetailField.checked ) // Radio Button "checked"
							oDetailField.listField.value = oDetailField.value ;
					}
					else
					***/ 
					if ( sType == "checkbox" )
					{
						if ( oDetailField.checked ) // Check Box "checked"
							oDetailField.listField.value = "1" ;
						else
							oDetailField.listField.value = "0" ;
					}
					else
					{
						oDetailField.listField.value = oDetailField.value ;
					}
				}
				else
				{
					alert ( "No 'listField' attribute for field '"+key+"' !");
				}
			}
			else
			{
				alert ( "Field '"+key+"' not found !");
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.xmlString = function(sVal)
	{
		var sXml = "" ;
		for ( var i=0 ; i < sVal.length ; i++ )
		{
			c = sVal.charAt(i) ;
			switch(c)
			{
				case "<"  : sXml += "&lt;" ; break ;
				case ">"  : sXml += "&gt;" ; break ;
				case "&"  : sXml += "&amp;" ; break ;
				case "\"" : sXml += "&quot;" ; break ;
				default : sXml += c ; 
			}
		}
		/**
		if ( sVal.length != sXml.length )
		{
			alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
		}
		**/
		return sXml ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.xmlString2 = function(sVal)
	{
		var sXml = sVal ;
		sXml = sXml.replace(/&/g, "&amp;" ); // A faire en premier 
		sXml = sXml.replace(/</g, "&lt;" );
 		sXml = sXml.replace(/>/g, "&gt;" );
		sXml = sXml.replace(/\"/g, "&quot;" );
		/**
		if ( sVal.length != sXml.length )
		{
			alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
		}
		**/
		return sXml ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.serializeField = function(oField, sFieldName)
	{
		//alert ( "serializeField : " + sFieldName );
		// var sBuffer = " " + sFieldName + "=\"" + oField.value + "\"" ;
		var sBuffer = " " + sFieldName + "=\"" + this.xmlString2(oField.value) + "\"" ;
		//alert ( "buffer = " + sBuffer );
		this._sSerializedFields += sBuffer ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.forAllFields = function(oElement,oFunction ) // Traitement rcursif des Elements "enfants" d'un Element 
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						//--- Application de la fonction passe en paramtre 
						// oFunction(oChild,sFieldName); // NOK avec mthode d'un objet !
						this.serializeField ( oChild,sFieldName);
					}
				}
				
				//--- Enfants (par rcursivit)
				this.forAllFields(oChild,oFunction) ;
			}
		}
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.serializeFields = function(sTagName)
	{
		if ( sTagName == null ) sTagName = "row" ;
		this._sSerializedFields = "<data>\n" ;
		this._sSerializedFields += this.startSerialization() ;
		//--- Pour chaque ligne "TR" du "TBODY"
		for ( var i = 0 ; i < this._oTBodyList.rows.length ; i++ )
		{
			//this._sSerializedFields += "<row>" ;
			//this._sSerializedFields += "<fields " ;
			this._sSerializedFields += "<" + sTagName + " " ;
			//--- Serialisation de tous les champs de la ligne 
			this.forAllFields( this._oTBodyList.rows[i], this.serializeField );
			this._sSerializedFields += " />\n" ; // Fin de <fields .. />
			//this._sSerializedFields += "</row>\n" ;
		}
		this._sSerializedFields += this.endSerialization() ;
		this._sSerializedFields += "</data>" ;
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.clearListContent = function()
	{
		alert ( "clearListContent()" ) ; 
		if ( this._oDivList == null ) 
		{ 
			alert ( "ERROR: List DIV is null !" ) ; 
			return ;
		}
		//this._oDivList.innerHTML = "" ;
		this._oDivList.innerHTML = "<table><tbody></tbody></table>" ;
		//this.clearStructure();
		this.initStructure();
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.setListContentFromHtml = function( sHtmlData )
	{
		if ( sHtmlData == null )
		{
			alert ( "ERROR: No HTML Data " ) ; 
			return ;
		}
		if ( this._oDivList == null ) 
		{ 
			alert ( "ERROR: List DIV is null !" ) ; 
			return ;
		}
		
		//--- Set the new content in the LIST
		s1 = "<div id='fwkDivData' ><table border='0' cellpadding='0' cellspacing='0' width='100%'><tbody><tr>" ;
		s2 = "</tr></tbody></table></div>" ;

		s11 = "<table border='0' cellpadding='0' cellspacing='0' width='100%'>" ;
		s22 = "</table>" ;
		sHtmlString = s11 + sHtmlData + s22 ;
		
		alert ( "setListContentFromHtml(..) sHtmlString : \n" + sHtmlString ) ; 

var oDiv = this._oDivList ;
alert ( "oDiv.childNodes.length = " + oDiv.childNodes.length );
/***
var i=0;
for ( i=0 ; i < oDiv.childNodes.length ; i++ )
{
    alert ( "Remove child : i = " + i + " - " + oDiv.childNodes[i] );
	oDiv.removeChild(oDiv.childNodes[i]);
}
***/
//--- Vidage de la DIV (OK / Gecko )
alert ( "Vidage de la DIV "  );
var range = document.createRange();
range.selectNodeContents(oDiv);
range.deleteContents();
alert ( "oDiv.childNodes.length = " + oDiv.childNodes.length );


alert ( "DOM Parsing ... "  );
var parser = new DOMParser();
var xmlRoot = parser.parseFromString(sHtmlString, "text/xml");
//var xmlRoot = parser.parseFromString("<h2>NEW</h2>", "text/html"); // Provoque une erreur d'excution 
alert ( "xmlRoot.childNodes.length = " + xmlRoot.childNodes.length );
/***
for ( i=0 ; i < xmlRoot.childNodes.length ; i++ )
{
//    alert ( "Append child : i = " + i + " - " + xmlRoot.childNodes[i] );
	document.getElementById("fwkDivContainer").appendChild ( xmlRoot.childNodes[i] );
}
***/

alert ( "Cration & initialisation du fragment "  );
var frag = document.createDocumentFragment();
// frag.write("<div>New Div Content</div>"); // Not supported / GEcko
frag.appendChild(xmlRoot);
alert ( "frag.childNodes.length = " + frag.childNodes.length );

alert ( "Affectation du nouveau contenu la DIV "  );
this._oDivList.appendChild(frag);

//this._oDivList.appendChild(xmlRoot.documentElement);


//		this._oDivList.innerHTML = s1 + sHtmlData + s2 ;

		this.initStructure();
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.setListContentFromUrl = function( sDataURL )
	{
		alert ( "setListContentFromUrl ( "+ sDataURL + " )" ) ; 
		if ( this._oRequester == null )
		{
			alert ( "ERROR: Http requester is null ! \n Cannot send request. " );
			return ;
		}
		//--- Request to get data from the server
		this._oRequester.open("POST", sDataURL, false );
		//alert("After OPEN");
		this._oRequester.send(null);
		//alert("After SEND");

		this.setListContentFromHtml ( this._oRequester.responseText ) ;
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.save = function( sTagName )
	{
		//alert ( " TRACE : save()" );
		if ( ( this._oTBodyList != null ) && ( this._oTBodyList.rows.length > 0 ) )
		{ 		
			this.applyDetailToList();
		}
		this.serializeFields(sTagName) ;
		//alert ( " Buffer = \n [" + this._sSerializedFields + "]" );
		
		//--- Affectation des donnes dans le champ cach
		// var oField = document.getElementById("dataToPost");
		var oField = document.getElementById( this._sPostTextId );
		//var oField = oDocument.getElementById( this._sPostTextId );
		if ( oField != null )
		{
			oField.value = this._sSerializedFields ;
		}
		else
		{
			alert ( "Field to post data not found ! \n Id = '" + this._sPostTextId +"' " );
		}
		//--- Submit via le formulaire
		// var oForm = document.getElementById("formToPost");
		var oForm = document.getElementById( this._sPostFormId );
		if ( oForm != null )
		{
			oForm.submit();
		}
		else
		{
			alert ( "Form to post data not found ! \n Id = '" + this._sPostFormId + "' " );
		}
	}
	//------------------------------------------------------------------------------
	this.listChildNodes = function()
	{
		if ( this._oTBodyList == null )
		{
			alert("ERROR: listChildNodes : _oTBodyList == null ! ");
			return;
		}
		if ( this._oTBodyList.childNodes )
		{
			alert ( "childNodes.length = " + this._oTBodyList.childNodes.length );
		}
		else
		{
			alert ( "!!! No childNodes " );
		}
	}
	
	//------------------------------------------------------------------------------
	// EVENEMENTS ( A SURCHARGER AU NIVEAU DE L'APPLICATION )
	//------------------------------------------------------------------------------
	this.beforeSelectRow = function() { return true ; }
	this.afterSelectRow  = function()  { return true ; }
	this.startSerialization = function()  { return "" ; }
	this.endSerialization   = function()  { return "" ; }

} //--- End of object definition 
