//------------------------------------------------------------------------------
// fwkListDetail.js
//------------------------------------------------------------------------------
// Uses : none
//------------------------------------------------------------------------------
// Version : 1.2  ( 11/10/2005 )
// Author  : Laurent Gurin 
//------------------------------------------------------------------------------

function isNavNetscape()
{
   if ( navigator.appName.indexOf("Netscape") >= 0 )  return true ;
   else return false ;
}
function isNavMicrosoft()
{
   if ( navigator.appName.indexOf("Microsoft") >= 0 )  return true ;
   else return false ;
}
/**
function loadinparent(url, closeSelf)
{
	self.opener.location = url;
	if(closeSelf) self.close();
}
function listFrames()
{
	if ( window.frames != null ) 
	{
		window.alert("This window has " + window.frames.length + " frame(s)" );
	    for ( var i = 0; i< window.frames.length; i++ )
	    {
	        window.alert ("Frame " +i+ " : name = "+window.frames[i].name);
	    }
	}
}	
***/

//------------------------------------------------------------------------------
// OBJECT "ListDetail"
//------------------------------------------------------------------------------
//function ListDetail( sDivListId, sDivDetailId, sRowTemplateId )
function ListDetail( sDivDetailId, sFrameListName, sListUrl, sRowTemplateId )
{
	// alert ( "Constructor ( " + sDivListId + ", " + sDivDetailId + " ) " );
	var sErrMsg = "ERROR: ListDetail() constructor : " ;
	if ( sDivDetailId == null ) alert ( sErrMsg + "1st argument is null ( sDivDetailId )" ) ;
	if ( sFrameListName == null ) alert ( sErrMsg + "2nd argument is null ( sFrameListName )" ) ;
	if ( sListUrl == null ) alert ( sErrMsg + "3th argument is null ( List URL )" ) ;
	if ( sRowTemplateId == null ) alert ( sErrMsg + "4th argument is null ( Row Template Id )" ) ;
	
	//------------------------------------------------------------------------------
	// CONSTANTS
	//------------------------------------------------------------------------------
	this.ACTION_LOAD  = 1 ;
	this.ACTION_CLEAR = 2 ;
	
	//------------------------------------------------------------------------------
	// ATTRIBUTES
	//------------------------------------------------------------------------------
	this._sColorSelected    = "blue" ;
	this._sColorNormal      = "#DDDDDD" ;
	this._sPostFormId       = "formToPost" ;
	this._sPostTextId       = "textToPost" ;

	this._sDivDetailId      = sDivDetailId ;
	this._sFrameListName    = sFrameListName ;
	this._sListUrl          = sListUrl ;
	this._sRowTemplateId    = sRowTemplateId ;

	this._actionType        = 0 ; // ACTION_LOAD or ACTION_CLEAR
	this._currentLineTR     = null ;
	this._currentLineDIV    = null ;
	this._aDetailFields     = new Array() ; // Tableau des champs de la "zone detail"
	this._sSerializedFields = "" ;

	this._oListFrame        = null ;
	this._oTBodyList        = null ;
	this._oTemplateTR       = null ; 

	this._oDivDetail        = null ;

	this._oSelectedRowTR    = null ;
	this._oSelectedRowDIV   = null ;

	this._oRequester        = null ; // HTTP Requester 
	
	//------------------------------------------------------------------------------
	// METHODES D'INITIALISATION
	//------------------------------------------------------------------------------
	// Initialisation de tous les champs avec "FieldName" contenus dans le container "DETAIL" 
	this.initDetailFields = function(oElement)  // Traitement rcursif des Elements "enfants" d'un Element
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						//--- Ajout du champ associ  son nom
						this._aDetailFields[sFieldName] = oChild ; 
					}
				/**
					alert ( "oChild : " 
					+ "\n id = " + oChild.id 
					+ "\n tagName  = " + oChild.tagName 
					+ "\n nodeName = " + oChild.nodeName
					+ "\n nodeType = " + oChild.nodeType 
					+ "\n localName = " + oChild.localName 
					+ "\n FieldName = " + sFieldName ) ;
				**/
				}
				
				//--- Enfants (par rcursivit)
				this.initDetailFields(oChild) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	this.showDetailFields = function()  
	{
		var s = "" ;
		for ( key in this._aDetailFields )
		{
			s = s + key + " : " + this._aDetailFields[key] + "\n" ;
		}
		alert ( "this._aDetailFields : \n" + s ) ; 
	}
		
	//------------------------------------------------------------------------------
	// INITIALISATIONS
	//------------------------------------------------------------------------------	
	this.init = function()  
	{
		//alert ( "init()" ) ; 
		//--- HTTP REQUESTER
		if (window.ActiveXObject) 
		{
			//--- I.E.
			this._oRequester = new ActiveXObject("Microsoft.XMLHTTP") ;
		}
		else if (window.XMLHttpRequest)
		{
			//--- Mozilla
			this._oRequester = new XMLHttpRequest();
		}
	
		//--- ROW TEMPLATE 
		if ( this._sRowTemplateId == null )
		{
			alert ( "init() : no id for the ROW TEMPLATE ! ") ; 	
		}
		else
		{
			//--- Container "DIV" de la partie "DETAIL"
			this._oTemplateTR = document.getElementById( this._sRowTemplateId );
			if ( this._oTemplateTR == null ) 
			{ 
				alert ( "init() : Cannot found ROW TEMPLATE with id = " + this._sRowTemplateId ) ; 
			}
		}

		//--- LIST CONTAINER ( IFRAME )
		if ( this._sFrameListName == null )
		{
			alert ( "init() : no FRAME NAME for the list container ! ") ; 	
		}
		else
		{
			this._oListFrame = window.frames[ this._sFrameListName ];
			if ( this._oListFrame == null )
			{
				alert ( "init() : Cannot found frame with name = " + this._sFrameListName );
			}
		}
		
		//--- DETAIL CONTAINER  ( DIV )
		if ( this._sDivDetailId == null )
		{
			alert ( "init() : no DIV id for the detail container ! ") ; 	
		}
		else
		{
			//--- Container "DIV" de la partie "DETAIL"
			this._oDivDetail = document.getElementById( this._sDivDetailId );
			if ( this._oDivDetail == null ) 
			{ 
				alert ( "init() : Cannot found DIV with id = " + this._sDivDetailId ) ; 
			}
			else
			{
				this.initDetailFields(this._oDivDetail);
				//this.showDetailFields(); // For debug
			}
		}
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.getResponseFromUrl = function( sURL )
	{
		alert ( "getResponseFromUrl"+ sURL + " )" ) ; 
		if ( this._oRequester == null )
		{
			alert ( "ERROR: Http requester is null ! \n Cannot send request. " );
			return ;
		}
		//--- Request to get data from the server
		this._oRequester.open("POST", sURL, false );
		//alert("After OPEN");
		this._oRequester.send(null);
		//alert("After SEND");

		return this._oRequester.responseText ;
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.cancelEvent = function(evt) //--- Arrte la propagation de l'vnement 
	{
		if ( evt == null ) 
		{
			alert ( "cancelEvent() : evt is null " );
			return;
		}
		if ( isNavMicrosoft() )
		{
			//--- Spcifique Internet Explorer
			evt.cancelBubble = true;   
		}
		else if ( isNavNetscape() ) 
		{
			//--- Spcifique Mozilla / Netscape
			//alert ( "Navigateur is NETSCAPE");
			if ( evt == null ) 
			{
				alert ( "event is null ! " );
			}
			else
			{
				if ( evt.stopPropagation == null ) alert ( "stopPropagation is null ! ");
				else evt.stopPropagation();
			}
		}
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.getParentTR = function(object)
	{
		//--- Retourne l'objet 'TR' contenant l'objet pass en parametre
		//--- On remonte dans la hirarchie jusqu'a trouver un objet "TR" 
		var oNode = object.parentNode ;
		while ( oNode.tagName != "TR" )
		{
			oNode = oNode.parentNode ;
		}
		return oNode ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.showRowStatus = function(oTR)
	{
		if ( oTR != null )
		{
			//var key = oTR.getAttribute("key");
			window.status = oTR.rowIndex ; // + " ( key = " + key + " )" ;
		}
		else
		{
			window.status= "???" ;
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.getRowCount = function()
	{
		if ( this._oTBodyList != null )
		{
			return this._oTBodyList.rows.length ;
		}
		else
		{
			return 0 ;
		}	
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.noCurrentLine = function()
	{
		this._currentLineTR  = null ;
		this._currentLineDIV = null ;
		this.clearDetail(); // No line selected => nothing in the detail
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.changeCurrentLine = function(oTR,oDIV)
	{
		//alert("changeCurrentLine");
		if ( oTR == null )
		{
			alert ( "changeCurrentLine : oTR is null ! ") ;
			return ;
		}
		if ( oDIV == null )
		{
			alert ( "changeCurrentLine : oDIV is null ! ") ;
			return ;
		}
		
		this.beforeSelectRow(oTR,oDIV); //--- EVENEMENT (A SURCHARGER)
		if ( this._currentLineTR != null )
		{
			this.applyDetailToList() ;
		}
		if ( this._currentLineDIV != null )
		{
			this._currentLineDIV.style.backgroundColor = this._sColorNormal ; 
		}
		this._currentLineTR  = oTR ;
		this._currentLineDIV = oDIV ;
		this._currentLineDIV.style.backgroundColor = this._sColorSelected ;

		//--- Affichage des information de la nouvelle ligne courante 
		this.showRowStatus(oTR);
		this.showDetail(oTR); //--- Affichage de la partie "DETAIL" de la ligne
		this.afterSelectRow(oTR,oDIV); //--- EVENEMENT (A SURCHARGER)
	}
	//------------------------------------------------------------------------------
	// METHODE :  
	//------------------------------------------------------------------------------
	this.selectLineTR = function(oTR)
	{
		//--- Si la ligne est dj slectionne on ne fait rien 
		if ( oTR === this._currentLineTR ) return ; // Oprateur "STRICTEMENT EGAL"
		var oDIV = oTR.getElementsByTagName("div")[0] ; // Premier Tag DIV contenu dans TR
		this.changeCurrentLine(oTR, oDIV);
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectLineDIV = function(oDIV)
	{
		//--- Si la ligne est dj slectionne on ne fait rien 
		if ( oDIV === this._currentLineDIV ) return ; // Oprateur "STRICTEMENT EGAL"
		var oTR = this.getParentTR(oDIV); // Tag TR qui contient la DIV
		this.changeCurrentLine( oTR, oDIV );
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectLine = function(obj)
	{
		this.selectLineDIV( obj );
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.setColors = function(sNormal, sSelected)
	{
		this._sColorNormal      = sNormal ;
		this._sColorSelected    = sSelected ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.selectFirstLine = function()
	{
		//alert ( "selectFirstLine()" ) ;
		if ( this._oTBodyList != null )
		{
			if ( this._oTBodyList.rows.length > 0 ) this.selectLineTR(this._oTBodyList.rows[0]) ;
		}
		else
		{
			alert ( "selectFirstLine : object oTBodyList is null ! ") ;
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowUp = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowUp ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveUp : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
	
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex > 0 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex-1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex-1]);		
		}
		else
		{
			alert("On est au dbut !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.moveRowDown = function(object)
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//alert ( " TRACE : moveRowDown ...");
	
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "moveRowDown : oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		var iCurrentIndex = oTR.rowIndex ;
		if ( iCurrentIndex < this._oTBodyList.rows.length-1 )
		{
			this._oTBodyList.moveRow(iCurrentIndex, iCurrentIndex+1);
			this.selectLineTR(this._oTBodyList.rows[iCurrentIndex+1]);		
		}
		else
		{
			alert("On est  la fin !");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.deleteRow = function(object) // NB nom "deleteRow" rserv sous Mozilla 
	{
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
		//cancelEvent inutile la ligne est supprime => pas de propagation
		
		if ( this._oTBodyList.rows.length > 0 ) // Si il reste au moins une ligne
		{
			var oTR    = this.getParentTR(object);
			if ( oTR == null ) { alert ( "deleteRow : oTR is null ! " ) ; return ; }
		
			//alert ( "rowIndex to delete : " + oTR.rowIndex );
			var iRowIndexToDelete = oTR.rowIndex ;
			this._oTBodyList.deleteRow(iRowIndexToDelete);

			//alert ( "rows.length = " + this._oTBodyList.rows.length );
			if ( this._oTBodyList.rows.length > 0 )
			{
				//--- The list is not void
				if ( iRowIndexToDelete < this._oTBodyList.rows.length )
				{
					this.selectLineTR( this._oTBodyList.rows[iRowIndexToDelete] );
				}
				else
				{
					this.selectLineTR( this._oTBodyList.rows [ this._oTBodyList.rows.length-1 ] ) ;
				}
			}
			else
			{
				//--- The list is void => No current line
				this.noCurrentLine();
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.deleteSelectedRow = function()
	{
		if ( this._currentLineDIV != null )
		{
			this.deleteRow( this._currentLineDIV );
		}
		else
		{
			alert ( "No selected row ");
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.insertBeforeRow = function(object) 
	{
		var oTR    = this.getParentTR(object);
		if ( oTR == null ) { alert ( "oTR is null ! " ) ; return ; }
		//alert ( "oTR trouv ");
		
		//--- Insertion d'une nouvelle ligne (TR)
		//alert ( "rowIndex to insert : " + oTR.rowIndex );
		var oNewTR = this._oTBodyList.insertRow(oTR.rowIndex);	
	
		this.initNewRow(oNewTR);
		this.selectLineTR(oNewTR); // Select the new line as current line
	}
	//------------------------------------------------------------------------------
	this.insertBeforeSelectedRow = function() 
	{
		if ( this._currentLineDIV != null )
		{
			this.insertBeforeRow( this._currentLineDIV );
		}
		else
		{
			alert ( "No selected row ");
		}
	}
	//------------------------------------------------------------------------------
	this.insertBeforeRowEvent = function(object, evt) 
	{
		//alert("insertBeforeRowEvent()");
		if ( evt == null ) alert ( "evt is null ");
		this.cancelEvent(evt); // Cancel Event (vite Click -> Select Row)
		this.insertBeforeRow(object);
	}	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.getTBodyList = function()  
	{
		var TBODY_ID = "fwkTBodyListData" ;
		var oTBody = null ;
		
		if ( this._oListFrame == null ) 
		{ 
			alert ( "ERROR: getTBodyList(): FRAME LIST is null !" ) ; 
		}
		else
		{
			oTBody = this._oListFrame.document.getElementById( TBODY_ID );
			if ( oTBody == null ) 
			{ 
				alert ( "ERROR: getTBodyList(): cannot found TBODY with id = " + TBODY_ID + " in list frame ! " ) ; 
			}			
		}
		return oTBody ;
	}	
	//------------------------------------------------------------------------------
	this.fwkAfterLoadList = function()  
	{	
		if ( this._actionType == this.ACTION_LOAD )
		{
			//--- After a REAL LOAD (data from URL)
			this._oTBodyList = this.getTBodyList();
			//alert("setTBodyList() : " + ( this._oTBodyList == null ? "null" : "OK" ) );
			this.afterLoadList(); // CallBack method
		}
		else if ( this._actionType == this.ACTION_CLEAR )
		{
			//--- After a CLEAR ( URL = "blank" )
			// this._oTBodyList  stay NULL
			this.afterClearList(); // CallBack method
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.addRow = function()  
	{
		//alert ( "addRow()");
		//this.cancelEvent(); // Cancel Event (vite Click -> Select Row)
	
		//--- Insertion d'une nouvelle ligne (TR)
		//alert ( "rowIndex to insert : " + oTR.rowIndex );
		if ( this._oTBodyList == null )
		{
			alert("The list is not initialized.");
		}
		else
		{
			//alert("addRow() : rows.length = " + this._oTBodyList.rows.length);
			var oNewTR = this._oTBodyList.insertRow(this._oTBodyList.rows.length); // Ok / IE & Mozilla
			this.initNewRow(oNewTR);
			this.selectLineTR(oNewTR);
		}
	}
	
	//------------------------------------------------------------------------------
	this.getDivTemplate = function(oTemplateTR)  
	{	
	/***
		if ( oTemplateTR.hasChildNodes() )
		{
			alert("oTemplateTR has child nodes" );
		}
		else
		{
			alert("oTemplateTR has NO child nodes" );
		}
		var oTD  = oTemplateTR.getElementsByTagName("td")[0] ;
		if ( oTD != null  )
		{
			alert("oTemplateTR has TD " );
		}
		else
		{
			alert("oTemplateTR has NO TD" );
		}
	***/
		var oDiv = oTemplateTR.getElementsByTagName("div")[0] ;
		if ( oDiv != null )
		{
			alert("oTemplateTR has DIV " );
		}
		else
		{
			alert("oTemplateTR has NO DIV" );
		}
		return oDiv ;
	}
	//------------------------------------------------------------------------------
	this.getTdTemplate = function(oTemplateTR)  
	{	
		var oTD  = oTemplateTR.getElementsByTagName("td")[0] ;
		if ( oTD != null  )
		{
			//alert("oTemplateTR has TD " );
		}
		else
		{
			alert("oTemplateTR has NO TD" );
		}
		return oTD ;
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.initNewRow = function(oNewTR)  
	{	
		//alert ( "initNewRow()");
		//----------------------------------------------------------------------
		// Application du Template  la nouvelle ligne 
		//----------------------------------------------------------------------
		if ( this._oTemplateTR == null )
		{
			alert ( "ERROR: initNewRow() : _oTemplateTR is null ! " );
			return;
		}
		//alert ( "TR inner html = " + this._oTemplateTR.innerHTML ); 
		if ( isNavMicrosoft() )
		{
			//oNewTR.innerHTML = this._oTemplateTR.innerHTML ; // Impossible sous IE (Error JS)
			//--- Create a new CELL ( <TD> ) in the ROW ( <TR> ) 
			var oNewTD = oNewTR.insertCell(0);

			// var oDiv = this.getDivTemplate( this._oTemplateTR );
			// alert ( "oDiv = " + oDiv.innerHTML );			
			// var oNewDiv = document.createElement("DIV");
			// oTD.appendChild( oNewDiv );

			//--- Set the <TD> class & innerHTML from the <TD> of the row template
			var oTD = this.getTdTemplate( this._oTemplateTR );
			//alert ( "oTD.className = " + oTD.className );
			oNewTD.className = oTD.className ;
			//alert ( "oTD.innerHTML = " + oTD.innerHTML );
			oNewTD.innerHTML = oTD.innerHTML ;
		}
		else
		{
			//alert ( "template HTML : \n" + this._oTemplateTR.innerHTML ) ;
			//--- With Mozilla/Firefox : use innerHTML
			oNewTR.innerHTML = this._oTemplateTR.innerHTML ; // Impossible sous IE (Error JS)
		}
	}
	//------------------------------------------------------------------------------
/***
	this.listIsVoid = function()  
	{	
		if ( this._oTBodyList == null )
		{
			alert ( "Liste table : TBody is null => Set TABLE TEMPLATE" );
			return true ;
		}
		if ( this._oTBodyList.rows == null  ) 
		{
			alert ( "Liste table : TBody.rows is null => Set TABLE TEMPLATE" );
			return true ;
		}
		if ( this._oTBodyList.rows.length == 0 ) 
		{
			alert ( "Liste table : TBody.rows.length == 0 => Set TABLE TEMPLATE" );
			return true ;
		}
		return false ;
	}
***/
	//------------------------------------------------------------------------------
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.showDetail = function(oElement) // oElement = "<TR>" 
	{
		if ( oElement == null ) { alert ( "showDetail : oElement is null ! ") ; return ; }
		this.applyListToDetail(oElement);
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	// Pour chaque "Field" de la ligne (ou des ses lments enfant) rcupration du champ correspondant 
	// dans la zone dtail ( via le tableau des champs de la zone dtail )
	// Association du "champ ligne" au "champ dtail" ( en vue du "applyDetailToList" )
	// Valorisation du "champ dtail"
	//------------------------------------------------------------------------------
	this.applyListToDetail = function(oElement) 
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var bField = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				bField     = null ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						var oDetailField = this._aDetailFields[sFieldName] ;
						if ( oDetailField != null )
						{
							//alert ( "set field value : " + oChild.value ) ;
							oDetailField.listField = oChild ;
							var sType = oDetailField.getAttribute("type") ;
						/***
							if ( sType == "radio" ) // TODO (a valider)
							{
	        						if ( DetailField.value == oChild.value ) 
	        							oDetailField.checked = true ;
	        						else
	        							oDetailField.checked = false ;								
							}
							else 
						***/
							if ( sType == "checkbox" )
							{
	        						if ( oChild.value == "1" ) 
	        							oDetailField.checked = true ;
	        						else
	        							oDetailField.checked = false ;								
							}
							else
							{
								oDetailField.value = oChild.value ;
							}
						}
						else
						{
							/* Ce n'est pas une erreur tous les champs ne figurent pas forcment dans le dtail
							alert ( "cannot found field  : " + sFieldName 
								+ " in _aDetailFields[]"  ) ;
							*/
						}
					}
	/***
					alert ( "applyListToDetail  oChild : " 
					+ "\n id = " + oChild.id 
					+ "\n tagName  = " + oChild.tagName 
					+ "\n nodeName = " + oChild.nodeName
					+ "\n nodeType = " + oChild.nodeType 
					+ "\n localName = " + oChild.localName 
					+ "\n FieldName = " + sFieldName 
					+ "\n detailField = " + bField ) ;
	***/
				}
				
				//--- Enfants (par rcursivit)
				this.applyListToDetail(oChild) ;
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.clearDetail = function() 
	{
		var oDetailField = null ;
		for ( key in this._aDetailFields )
		{
			//alert ( "applyDetailToList : field " + key );
			oDetailField = this._aDetailFields[key] ;
			if ( oDetailField != null )
			{
				var sType = oDetailField.getAttribute("type") ;
				/***
				if ( sType == "radio" ) // TODO (a valider)
				{
					if ( oDetailField.checked ) // Radio Button "checked"
						oDetailField.listField.value = oDetailField.value ;
				}
				else
				***/ 
				if ( sType == "checkbox"  || sType == "radio" )
				{
					oDetailField.checked = false ;
				}
				else
				{
					oDetailField.value = "" ;
				}
			}
			else
			{
				alert ( "Field '"+key+"' not found !");
			}
		}
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.applyDetailToList = function() 
	{
		var oDetailField = null ;
		for ( key in this._aDetailFields )
		{
			//alert ( "applyDetailToList : field " + key );
			oDetailField = this._aDetailFields[key] ;
			if ( oDetailField != null )
			{
				if ( oDetailField.listField != null )
				{
					var sType = oDetailField.getAttribute("type") ;
					/***
					if ( sType == "radio" ) // TODO (a valider)
					{
						if ( oDetailField.checked ) // Radio Button "checked"
							oDetailField.listField.value = oDetailField.value ;
					}
					else
					***/ 
					if ( sType == "checkbox" )
					{
						if ( oDetailField.checked ) // Check Box "checked"
							oDetailField.listField.value = "1" ;
						else
							oDetailField.listField.value = "0" ;
					}
					else
					{
						oDetailField.listField.value = oDetailField.value ;
					}
				}
				else
				{
					alert ( "No 'listField' attribute for field '"+key+"' !");
				}
			}
			else
			{
				alert ( "Field '"+key+"' not found !");
			}
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.xmlString = function(sVal)
	{
		var sXml = "" ;
		for ( var i=0 ; i < sVal.length ; i++ )
		{
			c = sVal.charAt(i) ;
			switch(c)
			{
				case "<"  : sXml += "&lt;" ; break ;
				case ">"  : sXml += "&gt;" ; break ;
				case "&"  : sXml += "&amp;" ; break ;
				case "\"" : sXml += "&quot;" ; break ;
				default : sXml += c ; 
			}
		}
		/**
		if ( sVal.length != sXml.length )
		{
			alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
		}
		**/
		return sXml ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.xmlString2 = function(sVal)
	{
		var sXml = sVal ;
		sXml = sXml.replace(/&/g, "&amp;" ); // A faire en premier 
		sXml = sXml.replace(/</g, "&lt;" );
 		sXml = sXml.replace(/>/g, "&gt;" );
		sXml = sXml.replace(/\"/g, "&quot;" );
		/**
		if ( sVal.length != sXml.length )
		{
			alert ( "xmlString : [" + sVal + "] --> [" + sXml + "]" );
		}
		**/
		return sXml ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.serializeField = function(oField, sFieldName)
	{
		//alert ( "serializeField : " + sFieldName );
		// var sBuffer = " " + sFieldName + "=\"" + oField.value + "\"" ;
		var sBuffer = " " + sFieldName + "=\"" + this.xmlString2(oField.value) + "\"" ;
		//alert ( "buffer = " + sBuffer );
		this._sSerializedFields += sBuffer ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.forAllFields = function(oElement,oFunction ) // Traitement rcursif des Elements "enfants" d'un Element 
	{
		if ( oElement.hasChildNodes() == false )
		{
			return ;
		}
		else
		{
			var oChild = null ;
			var sFieldName = null ;
			for ( var i = 0 ; i < oElement.childNodes.length ; i++ )
			{
				oChild = oElement.childNodes[i] ;
				sFieldName = null ;
				// NB : tous les "elements" du DOM ne disposent pas de la mthode "getAttribute"
				if ( oChild.getAttribute != null )
				{
					if ( ( sFieldName = oChild.getAttribute("FieldName") ) != null )
					{
						//--- Application de la fonction passe en paramtre 
						// oFunction(oChild,sFieldName); // NOK avec mthode d'un objet !
						this.serializeField ( oChild,sFieldName);
					}
				}
				
				//--- Enfants (par rcursivit)
				this.forAllFields(oChild,oFunction) ;
			}
		}
	}

	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------
	this.serializeFields = function(sTagName)
	{
		if ( sTagName == null ) sTagName = "row" ;
		this._sSerializedFields = "<data>\n" ;
		this._sSerializedFields += this.startSerialization() ;
		//--- Pour chaque ligne "TR" du "TBODY"
		for ( var i = 0 ; i < this._oTBodyList.rows.length ; i++ )
		{
			//this._sSerializedFields += "<row>" ;
			//this._sSerializedFields += "<fields " ;
			this._sSerializedFields += "<" + sTagName + " " ;
			//--- Serialisation de tous les champs de la ligne 
			this.forAllFields( this._oTBodyList.rows[i], this.serializeField );
			this._sSerializedFields += " />\n" ; // Fin de <fields .. />
			//this._sSerializedFields += "</row>\n" ;
		}
		this._sSerializedFields += this.endSerialization() ;
		this._sSerializedFields += "</data>" ;
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.loadPage = function (sURL, oTarget)
	{
		if ( oTarget != null )
		{
			var sType = typeof oTarget ;
			//alert ( "TRACE:  target type = '" + sType +"'" );
			if ( sType == "string" )
			{
				//alert ( "TRACE: The target is a String " );
				var oTargetFrame = window.frames[oTarget];
				if ( oTargetFrame == null )
				{
					alert ( "ERROR: Invalid frame name : " + oTarget );
				}
				else
				{
					oTargetFrame.location = sURL ;
				}
			} 
			else if ( sType == "object" )
			{
				//alert ( "TRACE: The target is an Object " );
				if ( oTarget.location )
				{
					oTarget.location = sURL ;
				}
				else
				{
					alert ( "ERROR: Invalid TARGET object ! \n No location property in the object !" );
				}
			} 
			else
			{
				alert ( "ERROR: Invalid target type : '" + sType +"'" );
			}
		}
		else
		{
			window.location = sURL ;
		}
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.clearListContent = function()
	{
		//alert ( "clearListContent()" ) ; 
		this._actionType = this.ACTION_CLEAR ;
		this._oTBodyList = null ;
		this.loadPage("about:blank", this._oListFrame );
		//--- The list is void => No current line
		this.noCurrentLine();
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.loadListContent = function()
	{
		//alert ( "loadListContent" ) ; 
		this._actionType = this.ACTION_LOAD ;		
		this._oTBodyList = null ;
		this.loadPage(this._sListUrl, this._oListFrame );
		//this._oTBodyList = this.getTBodyList(); // pas ici (load pas fini => err)
	}
	
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.toXml = function( sTagName )
	{
		alert ( " TRACE : toXml()" );
		if ( ( this._oTBodyList != null ) && ( this._oTBodyList.rows.length > 0 ) )
		{ 		
			this.applyDetailToList();
		}
		this.serializeFields(sTagName) ;
		alert ( " toXml = \n [" + this._sSerializedFields + "]" );
		return this._sSerializedFields ;
	}
	//------------------------------------------------------------------------------
	// METHODE : 
	//------------------------------------------------------------------------------		
	this.save = function( sTagName )
	{
		this.toXml ( sTagName );
		//--- Affectation des donnes dans le champ cach
		// var oField = document.getElementById("dataToPost");
		var oField = document.getElementById( this._sPostTextId );
		//var oField = oDocument.getElementById( this._sPostTextId );
		if ( oField != null )
		{
			oField.value = this._sSerializedFields ;
		}
		else
		{
			alert ( "Field to post data not found ! \n Id = '" + this._sPostTextId +"' " );
		}
		//--- Submit via le formulaire
		// var oForm = document.getElementById("formToPost");
		var oForm = document.getElementById( this._sPostFormId );
		if ( oForm != null )
		{
			oForm.submit();
		}
		else
		{
			alert ( "Form to post data not found ! \n Id = '" + this._sPostFormId + "' " );
		}
	}
	//------------------------------------------------------------------------------
	this.listChildNodes = function()
	{
		if ( this._oTBodyList == null )
		{
			alert("ERROR: listChildNodes : _oTBodyList == null ! ");
			return;
		}
		if ( this._oTBodyList.childNodes )
		{
			alert ( "childNodes.length = " + this._oTBodyList.childNodes.length );
		}
		else
		{
			alert ( "!!! No childNodes " );
		}
	}
	
	//------------------------------------------------------------------------------
	// EVENEMENTS ( A SURCHARGER AU NIVEAU DE L'APPLICATION )
	//------------------------------------------------------------------------------
	this.afterLoadList = function() { return true ; }
	this.afterClearList = function() { return true ; }
	this.beforeSelectRow = function() { return true ; }
	this.afterSelectRow  = function()  { return true ; }
	this.startSerialization = function()  { return "" ; }
	this.endSerialization   = function()  { return "" ; }

} //--- End of object definition 
