package org.objectweb.telosys.admin;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;

import org.objectweb.telosys.common.TelosysServlet;

/**
 * 
 */

public class Console extends TelosysServlet
{
    protected static final String CONTENT_TYPE_TEXT_HTML  = "text/html";
    protected static final String CONTENT_TYPE_TEXT_PLAIN = "text/plain";
    
    protected static final int  STANDARD_CLASS_LOADER_TYPE = 1 ;
    protected static final int  THREAD_CLASS_LOADER_TYPE = 2 ;
    
    protected static final String JAVA_INFO = "java_info" ;
    protected static final String SERVLET_CLASS_LOADER  = "servlet_classloader" ;
    protected static final String THREAD_CLASS_LOADER  = "thread_classloader" ;
    protected static final String RESOURCES  = "resources" ;
    protected static final String RESOURCE_PATH  = "resource_path" ;
    protected static final String SERVLET_CONTEXT  = "servlet_context" ;
    protected static final String SESSIONS  = "sessions" ;
    protected static final String TELOSYS_CONF  = "telosys_conf" ;

    
    protected static final String LOAD_CLASS_FORM  = "load_class_form" ;
    protected static final String LOAD_CLASS       = "load_class" ;
    
    protected static final String LOAD_RESOURCE_FORM = "load_resource_form" ;
    protected static final String LOAD_RESOURCE      = "load_resource" ;

    
    //-----------------------------------------------------------------------------
    protected static void printBack(PrintWriter out, HttpServletRequest request) //throws ServletException, IOException
    {
        out.println("<hr>" );        
        out.println("<a href=\"" + request.getRequestURL() + "\" > &lt;&lt;&lt; Console menu </a>" );
        out.println("<hr>" );        
    }
    //-----------------------------------------------------------------------------
    protected static void openTable( PrintWriter out )
    {
        out.println("<table style='border-top:1px solid blue; border-left:1px solid blue;'><tbody>");
    }
    //-----------------------------------------------------------------------------
    protected static void closeTable( PrintWriter out )
    {
        out.println("</tbody></table>");
    }
    //-----------------------------------------------------------------------------
    protected static void printTR( PrintWriter out, String s1, String s2 )
    {
        out.print("<tr>");
        out.print("<td style='border-bottom:1px solid blue; border-right:1px solid blue;'>" + s1 + "</td>" );
        out.print("<td style='border-bottom:1px solid blue; border-right:1px solid blue;'>" + s2 + "</td>" );
        out.println("</tr>");
    }
    //-----------------------------------------------------------------------------
    protected static void printTR( PrintWriter out, String s1 )
    {
        out.print("<tr>");
        out.print("<td style='border-bottom:1px solid blue; border-right:1px solid blue;'>" + s1 + "</td>" );
        out.println("</tr>");
    }
    //-----------------------------------------------------------------------------
    protected static String href(HttpServletRequest request, String sQuery) 
    {
        return request.getRequestURL() + "?" + sQuery ;
    }

}