package org.objectweb.telosys.admin;

import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;

import org.objectweb.telosys.common.Telosys;

/**
 * 
 */

public class ConsoleTelosysConf extends Console
{

    //-----------------------------------------------------------------------------
    protected static void print( PrintWriter out, HttpServletRequest request )
    {
        out.println("<b><u> Telosys configuration : </u></b>");
        openTable( out );

        printTR(out, "Web App Context Name",    Telosys.getWebAppName() );
        printTR(out, "Web App Root Directory",  Telosys.getWebAppRootDir() );
//        printTR(out, "Configuration directory", Telosys.getConfigDirectory() );
//        printTR(out, "Properties file name",    Telosys.getPropertiesFile() );
        printTR(out, "SAX parser class",        Telosys.getSAXParserClassName() );
        printTR(out, "&nbsp;",  "&nbsp;" );
//        printTR(out, "transform('./myfile.txt')", Telosys.transformFileName("./myfile.txt") );
//        printTR(out, "transform('$ROOT/myfile.txt')", Telosys.transformFileName("$ROOT/myfile.txt") );
        
        closeTable( out );
        
        printBack(out, request);
    }
}