package org.objectweb.telosys.auth;

/**
 * User validator interface <br>
 * Describe the method needed to validate a user (login/password) and retrieve an application user
 * 
 * @author Laurent GUERIN
 *  
 */
public interface IUserValidator
{

    /**
     * Check the validity of the "login/password" and return an instance of application user
     * 
     * @param sLogin
     * @param sPassword
     * @return
     */
    public IAppUser validUser(String sLogin, String sPassword);

}