package org.objectweb.telosys.common;

/**
 * @author Laurent GUERIN
 * 
 */
public class TelosysException extends Exception 
{
	private static final long serialVersionUID = 1L;
    
    private static final TelosysClassLogger log = new TelosysClassLogger(TelosysException.class);

    /**
     * @param message
     */
    public TelosysException(String message)
    {
        super(message);
        Telosys.error("TelosysException : " + message);
        Telosys.error(this);
    }

    /**
     * @param message
     * @param cause
     */
    public TelosysException(String message, Throwable cause)
    {
        super(message, cause);
        Telosys.error("TelosysException : " + message + " ( cause : " + cause.toString() + ")");
        Telosys.error(this);

    }
}