package org.objectweb.telosys.common;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author Laurent GUERIN
 *
 */
public interface View
{
    public void generate(HttpServletRequest httpRequest, HttpServletResponse httpResponse) throws TelosysException ;
    
    /**
     * Returns the target URL or URI of the View 
     * @return
     */
    public String getTarget();

}
