package org.objectweb.telosys.rpl.xml;

import org.objectweb.telosys.common.TelosysException;

/**
 * @author Laurent GUERIN
 *
 */
public interface IXmlWrapperProvider
{

    /**
     * Returns an XML wrapper associated with the given bean class name
     * @param beanInstance
     * @return
     * @throws TelosysException
     */
    public IXmlWrapper getWrapper(Object beanInstance) ; 

    /**
     * Returns an XML wrapper associated with the given bean class name
     * @param beanClass
     * @return
     * @throws TelosysException
     */
    public IXmlWrapper getWrapper(Class beanClass) ;
    
}