package org.objectweb.telosys.screen.core;

/**
 * @author Laurent GUERIN
 * 
 */
public class ScreenError
{
    private int    _iCode = 0;

    private String _sText = "";

    /**
     *  
     */
    public ScreenError(int iErrorCode)
    {
        _iCode = iErrorCode;
    }

    public ScreenError(int iErrorCode, String sErrorMessage)
    {
        _iCode = iErrorCode;
        _sText = sErrorMessage;
    }

    public int getCode()
    {
        return _iCode;
    }

    public String getText()
    {
        return _sText;
    }
}