package org.objectweb.telosys.screen.core;

/**
 * "Old fashion" class for screen management implementation <br>
 * Since version 1.0.0 this class has been replaced by "StandardScreenManager" <br>
 * It is provided only for backward compatibility and will be decrated in future releases <br>
 * 
 * @author Laurent GUERIN
 *  
 */
public abstract class StandardScreenDataAccessor extends StandardScreenManager
{
    /**
     * Constructor for default database
     * 
     * @param screenDataClass :
     *            the ScreenData class
     */
    public StandardScreenDataAccessor(Class screenDataClass)
    {
        super(screenDataClass);
    }

    /**
     * Constructor for specific database 
     * 
     * @param screenDataClass :
     *            the ScreenData class
     * @param iDatabaseId :
     *            the id of the Database to use (to get a connection)
     */
    public StandardScreenDataAccessor(Class screenDataClass, int iDatabaseId)
    {
        super(screenDataClass, iDatabaseId);
    }

}
