package org.objectweb.telosys.uil.renderer;

import org.objectweb.telosys.common.TelosysObject;
import org.objectweb.telosys.uil.i18n.Translator;

/**
 * Renderer description<br>
 * 
 * @author Laurent GUERIN
 * 
 */
public final class Renderer extends TelosysObject 
{
    private String _sRendererJSP = null ;

    private Translator _translator = null ;
        
    /**
     * @param sRendererJSP
     * @param translator
     */
    public Renderer(String sRendererJSP, Translator translator )
    {
        super();
        _sRendererJSP = sRendererJSP;
        _translator = translator;
    }
    
    //---------------------------------------------------------------------------------------
    public String getJSP()
    {
        return _sRendererJSP;
    }
    
    //---------------------------------------------------------------------------------------
    public Translator getTranslator()
    {
        return _translator;
    }
    
    //---------------------------------------------------------------------------------------
    public boolean hasTranslator()
    {
        return _translator != null ? true : false ;
    }
    
//    //---------------------------------------------------------------------------------------
//    public String translate(String sKey, String sLanguage)
//    {
//        if ( _translator != null )
//        {
//            return _translator.translate( sKey, sLanguage);
//        }
//        return null ;
//    }    
    //---------------------------------------------------------------------------------------
}