package org.objectweb.telosys.uil.screenmap;

import org.objectweb.telosys.common.TelosysObject;

/**
 * @author Laurent GUERIN
 *
 */
public class ScreenMapElement extends TelosysObject
{
    private String  _sName = null ;

    private String  _sValue = null ;

    private String  _sContent = null ;

    /**
     * @param sName
     * @param sValue
     * @param sContent
     */
    public ScreenMapElement(String sName, String sValue, String sContent)
    {
        super();
        _sName = sName ;
        _sValue = sValue;
        _sContent = sContent;
    }
    
    public String getName()
    {
        return _sName;
    }

    public String getValue()
    {
        return _sValue;
    }
    
    public String getContent()
    {
        return _sContent;
    }
    
    public boolean isValue()
    {
        if ( _sValue == null ) return false ;
        if ( _sValue.trim().length() == 0 ) return false ;
        return true ;
    }
    
    public boolean isContent()
    {
        if ( _sContent == null ) return false ;
        if ( _sContent.trim().length() == 0 ) return false ;
        return true ;
    }
    
}
