package org.objectweb.telosys.uil.taglib;


/**
 * @author Laurent GUERIN
 *  
 */
public class ListDiv 
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------
    
    private int _iWidthMain = TagConst.WIDTH_NULL ;

    private int _iWidthHead = TagConst.WIDTH_NULL ;
    
    private int _iWidthBody = TagConst.WIDTH_NULL ;
    
    private String _sIdMain = null ;

    private String _sIdHead = null ;
    
    private String _sIdBody = null ;

    private boolean _bIdBodySet = false ; // v 1.0.1
        
    //----------------------------------------------------------------
    public ListDiv( String sIdMain, int iWidthMain )
    {
        super();
        _sIdMain = sIdMain ;
        _sIdHead = sIdMain + "Head" ; // Default Id 
        _sIdBody = sIdMain + "Body" ; // Default Id
        
        _iWidthMain = iWidthMain ;
        _iWidthHead = iWidthMain ;
        _iWidthBody = iWidthMain ;        
    }

    //----------------------------------------------------------------
    // Id
    //----------------------------------------------------------------
    public String getIdMain()
    {
        return _sIdMain ;
    }
    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public String getIdHead()
    {
        return _sIdHead ;
    }
    //----------------------------------------------------------------
    public void setIdHead(String s)
    {
        _sIdHead = s ;
    }
    //----------------------------------------------------------------
    //----------------------------------------------------------------
    public String getIdBody()
    {
        return _sIdBody ;
    }
    //----------------------------------------------------------------
    public void setIdBody(String s)
    {
        _sIdBody = s ;
        _bIdBodySet = true ;
    }
    //----------------------------------------------------------------
    public boolean isIdBodyNotYetSet () // v 1.0.1
    {
        return ( _bIdBodySet != true );
    }

    //----------------------------------------------------------------
    // Width
    //----------------------------------------------------------------
    public int getWidthMain()
    {
        return _iWidthMain ;
    }
    //----------------------------------------------------------------
    public int getWidthHead()
    {
        return _iWidthHead ;
    }
    //----------------------------------------------------------------
    public int getWidthBody()
    {
        return _iWidthBody ;
    }
    //----------------------------------------------------------------
    
}