package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.screenmap.ScreenMap;
import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 * 
 */
public class IncludeBody extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    // none
    
    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        ScreenMap screenMap = getScreenMap();        
        if (screenMap == null)
        {
            return (SKIP_BODY);
        }

        String sScreenBodyURL = screenMap.getScreenBodyPath();
        if (sScreenBodyURL == null)
        {
            tagLibError("Cannot get the screen body URL from the current screen map !");
            return (SKIP_BODY);
        }

        print(out, "<!-- SCREEN BODY  ( include URL " + sScreenBodyURL + " ) -->");
        //--- INCLUDE
        include(sScreenBodyURL);
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}