package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.util.web.ScreenURI;

/**
 * @author Laurent GUERIN
 *  
 */
public class UrlScreenmap extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String _sName        = null;

    private String _sType        = null;

    private String _sContextId   = null;

    private String _sContextName = null; // new in v 0.9.9 

    private String _sAction      = null;

    private String _sParams      = null; // new in v 0.9.9

    //----------------------------------------------------------------
    public void setName(String v) // Attribute "name"
    {
        _sName = v;
    }

    public void setType(String v) // Attribute "type"
    {
        _sType = v;
    }

    public void setId(String v) // Attribute "id"
    {
        _sContextId = v;
    }

    public void setContextname(String v) // Attribute "contextname"
    {
        _sContextName = v;
    }

    public void setAction(String v) // Attribute "action"
    {
        _sAction = v;
    }

    public void setParams(String v) // Attribute "params"
    {
        _sParams = v;
    }

    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        
        //--- "http://server:port/webapp/screenmap/name-type/id-ctx:action?params"
//        String sFullURL = TagCommons.getScreenMapURL(pageContext, _sName, _sType, _sContextId, _sContextName, 
//                _sAction, _sParams); 
//        print(out, sFullURL);
        
        ScreenURI uri = new ScreenURI(_sName, _sType, _sContextId, _sContextName, _sAction, _sParams);
        HttpServletRequest req = ( HttpServletRequest ) pageContext.getRequest() ;
        print(out, uri.getFullURL(req) );
        
        return (SKIP_BODY);
    }
    
    //----------------------------------------------------------------
}