package org.objectweb.telosys.uil.taglib.widget;

/**
 * Standard W3C envents ( HTML 4 )
 * 
 * @author Laurent GUERIN
 *  
 */
public class Event
{
    //--- Mouse events
    public final static String ON_CLICK      = "onclick";

    public final static String ON_DBL_CLICK  = "ondblclick";

    public final static String ON_MOUSE_DOWN = "onmousedown";

    public final static String ON_MOUSE_UP   = "onmouseup";

    public final static String ON_MOUSE_OVER = "onmouseover";

    public final static String ON_MOUSE_MOVE = "onmousemove";

    public final static String ON_MOUSE_OUT  = "onmouseout";

    //--- Keyboard events
    public final static String ON_KEY_PRESS  = "onkeypress";

    public final static String ON_KEY_DOWN   = "onkeydown";

    public final static String ON_KEY_UP     = "onkeyup";

    //--- Input field/element events
    public final static String ON_CHANGE     = "onchange";

    public final static String ON_SELECT     = "onselect";

    public final static String ON_FOCUS      = "onfocus";

    public final static String ON_BLUR       = "onblur";

    //--- Form events
    public final static String ON_SUBMIT     = "onsubmit";

    public final static String ON_RESET      = "onreset";

    //--- Body/Frameset events
    public final static String ON_LOAD       = "onload";

    public final static String ON_UNLOAD     = "onunload";
}