package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.GroupBoxHTML;
import org.objectweb.telosys.uil.taglib.widget.xul.GroupBoxXUL;

/**
 * @author Laurent GUERIN
 *  
 */
public class GroupBox extends GenericTag
{
    private static final String  TAG_NAME = "groupbox";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new GroupBoxHTML();

    private final static IWidget $xulGen  = new GroupBoxXUL();

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

//    private String               _sTxt    = null;

    /**
     * Constructor
     */
    public GroupBox()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

//    //----------------------------------------------------------------
//    public void setTxt(String v)
//    {
//        _sTxt = v;
//    }
//
//    public String getTxt()
//    {
//        return _sTxt;
//    }

    //----------------------------------------------------------------
    // Ouverture du TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        //      JspWriter out = pageContext.getOut() ;
        //      try {
        //          if(TagCommons.isHTML(pageContext))
        //              printStartTagHTML(out);
        //          else
        //              printStartTagXUL(out);
        //      }
        //      catch ( IOException ioex )
        //      {
        //          ioex.printStackTrace();
        //
        //      }

        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Fermeture du TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        //      JspWriter out = pageContext.getOut() ;
        //      try {
        //          if(TagCommons.isHTML(pageContext))
        //              printEndTagHTML(out);
        //          else
        //              printEndTagXUL(out);
        //      }
        //      catch ( IOException ioex )
        //      {
        //          ioex.printStackTrace();
        //   
        //      }
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }

}