package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.HtmlViewerHTML;


/**
 * @author Laurent GUERIN
 *  
 */
public class HtmlViewer extends GenericTag
{
    private static final String  TAG_NAME = "htmlviewer";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new HtmlViewerHTML(); 

    private final static IWidget $xulGen  = null ;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    
//    private String               _sOnPopulate    = null;

    /**
     * Constructor
     */
    public HtmlViewer()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }
    
//    //----------------------------------------------------------------
//    public void setOnpopulate(String v)
//    {
//        _sOnPopulate = v;
//    }
//
//    public String getOnpopulate()
//    {
//        return _sOnPopulate;
//    }

    //----------------------------------------------------------------
    // Open TAG
    //----------------------------------------------------------------
    public int doStartTag()
    {
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    // Close TAG
    //----------------------------------------------------------------
    public int doEndTag()
    {
        endTag();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
