package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.TextAreaHTML;


/**
 * @author Laurent GUERIN
 *  
 */
public class TextArea extends GenericPostbackTag // GenericTag
{
    private static final String TAG_NAME = "textarea";

//    public  static final int    WITDH_MIN      = 400 ;
//
//    public  static final int    WITDH_DEFAULT  = 540 ;
//    
//    public  static final int    HEIGHT_MIN     = 100 ;
//
//    public  static final int    HEIGHT_DEFAULT = 250 ;
    
    //----------------------------------------------------------------
    // Tool bar elements IDs
    //----------------------------------------------------------------
    
    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget $htmlGen = new TextAreaHTML() ;

    private final static IWidget $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------    
    private String              _sCols    = null ;

    private String              _sRows    = null ;

    /**
     * Constructor 
     */
    public TextArea()
    {
        super(TAG_NAME, $htmlGen, $xulGen);    
        setIdGeneration(true); // Automatic ID generation (if ID not set by user)        
    }
    
	//----------------------------------------------------------------
	public void setCols(String v)
	{
	    _sCols = v;
	}
	public String getCols()
	{
	    return _sCols;
	}
    
	//----------------------------------------------------------------
	public void setRows(String v)
	{
	    _sRows = v;
	}
	public String getRows()
	{
	    return _sRows;
	}

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
        startTag();
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
    /* (non-Javadoc)
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();        
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
