package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.ComboItem;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * HTML generation for ComboItem widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ComboItemHTML extends GenericHTML implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ComboItem tag = (ComboItem) genericTag ;
        
        out.print("<option " 
                + getIdAttr(tag)+ " "
                + getClassAttr(tag)+" "
                + getStyleAttr(tag)+" "
                //+ getTitleAttr(tag)+" " 
                //+ getTabindexAttr(tag)+" "
                );
        out.print("value=\"" + tag.getValue() + "\" ");
        //if ( tag.isSelected() )
        if ( tag.getSelectedAsBoolean() ) // v 0.9.9
        {
            out.print(" selected=\"selected\" ");            
        }
        out.print(">" + tag.getTxt() + "</option>");
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
}