package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Panel;

/**
 * HTML generation for Panel widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class PanelHTML extends GenericHTML implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Panel tag = (Panel) genericTag;
        //String sTxt = tag.getTxt();

        out.print( "<div " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");        
        //out.print(getSpecificStyleAttr(tag) + " "); // v 1.0.2
        out.print(getContainerStyleAttr(tag) + " "); // v 1.0.2
        out.print(getTitleAttr(tag) + " ");
        out.println(" >");        
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.print( "</div>");
    }
    //----------------------------------------------------------------
// v 1.0.2
//    private String getSpecificStyleAttr(Panel tag)
//    {        
//        if (tag.isPositionAbsolute())
//        {
//            return getStyleAttrWithPosition(tag);
//        }
//        else
//        {
//            //--- Style set by user + Width/Height + force "relative position"
//            String sStyle = getStyleFragUserStyle(tag) + getStyleFragWidthHeight(tag) + "position:relative;" ;
//            return " style=\"" + sStyle + "\" " ;            
//        }
//    }
}