package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.Hidden;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * XUL generation for Hidden tag
 * 
 * @author Laurent GUERIN
 *  
 */
public class HiddenXUL extends GenericXUL implements IWidget
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Hidden tag = (Hidden) genericTag;

        String sValue = tag.getValue();
        if (sValue == null)
        {
            sValue = "";
        }
        
        out.print("<textbox  hidden=\"true\" ");
        out.print(getIdAttr(tag) + " ");
//        out.print(getClassAttr(tag) + " ");
//        out.print(getStyleAttr(tag) + " ");
        out.print(" value=\"" + sValue + "\" />");
        out.println("");
    }

    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
}