package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.Label;

/**
 * XUL generation for Label widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class LabelXUL extends GenericXUL implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        Label tag = (Label) genericTag ;

        String sTxt = tag.getTxt() ;
        String sFor = tag.getFor() ; 

        out.print("<label ");
        out.print( getIdAttr(tag)+ " " );
//        out.print( getClassAttr(tag)+" " );
//        out.print( getStyleAttr(tag)+" " );
//        out.print( getTitleAttr(tag)+" " );
        if ( sTxt != null )
        {
            out.print(" value=\"" + sTxt + "\" ");            
        }        
        if ( sFor != null )
        {
            out.print(" control=\"" + sFor + "\" ");    // TODO : verify behavior         
        }        
        out.print("/>");
        out.println("");
    }
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
    }
}