package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;
import org.objectweb.telosys.uil.taglib.widget.TabBox;

/**
 * Widget HTML generator 
 * 
 * @author Laurent GUERIN
 *  
 */
public class TabBoxXUL extends GenericXUL implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        TabBox tag = (TabBox) genericTag ;
        
        out.print( "<tabbox " );
        out.print(getIdAttr(tag) + " ");
        out.print(getClassAttr(tag) + " ");
        //out.print(getStyleAttr(tag) + " ");
        //out.print(getTitleAttr(tag) + " ");
        //out.print(getTabindexAttr(tag) + " ");
        out.println(" >");        

    }    
    //----------------------------------------------------------------
    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        out.println( "</tabbox>" );
    }
    //----------------------------------------------------------------
}
