function fwkUpload(id)
{
	//--- Check field validity 
	var oField = document.getElementById(id);
	if ( oField == null )
	{
		fwkError("fwkUpload() : Cannot get INPUT FILE element (id='"+id+"')" ) ;
		return;
	}	
	if ( oField.value == null )
	{
		fwkError("fwkUpload() : File path is null (id='"+id+"')" ) ;
		return;
	}	
	if ( oField.value == "" )
	{
		fwkError("fwkUpload() : File path is void (id='"+id+"')" ) ;
		return;
	}
	
	//--- Try to submit 
	var sFormId = id + "_form" ;
	var form = document.getElementById(sFormId);
	if (form != null) 
	{
		form.submit();
	}
	else
	{
		fwkError("fwkUpload() : Cannot get FORM element (id='" + sFormId + "')" ) ;		
	}		
}
// Callback method called by the IFRAME when it receives the response 
// ( <IFRAME ... onload="fwkUploadCallBack(this)" > )
function fwkUploadCallBack(iframe,funct)
{
	if (iframe != null) 
	{
		var ifBody = iframe.contentWindow.document.body;
		if (ifBody != null) 
		{
			var inner = ifBody.innerHTML;
			if (inner != null) 
			{
				var indSpace = inner.indexOf(' ');
				if (indSpace > -1)
				{
					var code = parseInt(inner.substring(0,indSpace));
					var msg = inner.substring(indSpace+1);
					if (funct != null) 
					{
						funct(code, msg);
					}
					else
					{
						if (code != 0) 
						{
							alert("UPLOAD ERROR :\n" + msg);
						} 
					}
				}
			}
		}
	}
}