//--------------------------------------------------------------------
// Functions for the SpinEdit widget
//--------------------------------------------------------------------
function fwkSpinEditClick(id, step, digit, min, max) // min & max facultatifs
{
	var spin = document.getElementById(id);
	if ( spin != null )
	{
		// parseFloat : if invalid value, doesn't throw exception, just return NaN
		var val = parseFloat(spin.value); 
		if ( isNaN(val) ) val = 0 ;
		val += step;
		if ( max != null )
		{
			if ( val > max ) val = max ;
		}
		if ( min != null )
		{
			if ( val < min ) val = min ;
		}
		if (digit>=0)
		{
			val = val.toFixed(digit);
		}
		spin.value = val;
	}
}
//--------------------------------------------------------------------