package org.objectweb.telosys.common.data.old;

import org.w3c.dom.Document;


/**
 * @author Laurent GUERIN
 * 
 * 
 */
public interface XmlProvider
{
    public Document  getDocument();
    
    /**
     * Notify the ListItem provider that it will be used
     */
    public void beforeUse();
    
    /**
     * Notify the ListItem provider that it has been used
     */
    public void afterUse();

}