package org.objectweb.telosys.common.vo;

/**
 * Utility class providing access to the GenericVOList protected methods 
 * NB: reserved for framework internal usage
 *  
 * @author Laurent GUERIN
 *
 */
public final class InternalVOList
{
    public static void addElement(GenericVOList list, Object newElement)
    {
        list.addElement(newElement);
    }

    public static Object getElement(GenericVOList list, int index)
    {
        return list.getElement(index);
    }

    public static Object getFirstElement(GenericVOList list)
    {
        return list.getFirstElement();
    }

    public static Object getNextElement(GenericVOList list)
    {
        return list.getNextElement();
    }
    
    public static void insertElement(GenericVOList list, int index, Object newElement)
    {
        list.insertElement(index, newElement);
    }

    public static void removeElement(GenericVOList list, int index)
    {
        list.removeElement(index);
    }

    public static void removeElement(GenericVOList list, Object obj)
    {
        list.removeElement(obj);
    }

    public static void replaceElement(GenericVOList list, int index, Object obj)
    {
        list.replaceElement(index, obj);
    }

}
