package org.objectweb.telosys.dal.csv;

/**
 * CSV parser handler interface
 * 
 * @author Laurent GUERIN
 *  
 */
public interface ICSVHandler
{
    public void start();

    public void dataLine(int no, String sLine, String fields[]);

    public void commentLine(int no, String sLine);

    public void voidLine(int no);

    public void end();
}

