package org.objectweb.telosys.service;

import org.objectweb.telosys.common.TelosysObject;


/**
 * Standard base class to build services
 * 
 * @author Laurent GUERIN
 *
 */
public abstract class StandardScreenService extends TelosysObject implements ScreenService
{
    private String _sName = null ;
    
    private String _sRenderer = null ;

    private String _sSessionKey = null ;

    public void init ( String sName, String sRenderer, String sSessionKey )
    {
        _sName = sName ;
        _sRenderer = sRenderer ;
        _sSessionKey = sSessionKey ;
    }
    
    public String getName()
    {
        return _sName ;
    }
    
    public String getRenderer()
    {
        return _sRenderer ;
    }

    public String getSessionKey()
    {
        return _sSessionKey ;
    }

}
