package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;
import org.objectweb.telosys.uil.taglib.Page;
import org.objectweb.telosys.util.NumUtil;

/**
 * @author Laurent GUERIN
 *  
 */
public class Count extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // Private variables
    //----------------------------------------------------------------

    //----------------------------------------------------------------
    // Tag attributes
    //----------------------------------------------------------------
    private String             _sFormat = null ;

    public void setFormat(String v)
    {
        this._sFormat = v ; // keep as is            
    }

//    private String             _sBase;
//
//    public void setBase(String v)
//    {
//        this._sBase = v;
//    }
//
//    private int getBase()
//    {
//        int iBase = 0;
//        if (_sBase != null)
//        {
//            try
//            {
//                iBase = Integer.parseInt(_sBase);
//            } catch (NumberFormatException ex)
//            {
//                iBase = 0;
//            }
//        }
//        return iBase;
//    }
//
    //----------------------------------------------------------------
    // Tag open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();

        int iCount = Page.getIterationCount(pageContext);
//        int iBase = getBase();
//        iCount = iCount + iBase; // Alter the count with the given base

        if ( _sFormat != null )
        {
            print(out, NumUtil.formatInt(iCount, _sFormat) );
        }
        else
        {
            print(out, ""+iCount); // No format
        }            
        
        return (SKIP_BODY);
    }

    //----------------------------------------------------------------
}