package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 *  
 */
public class Include extends CommonTagSupport // TagSupport
{
    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------
    private String _sPath = null;

    public void setPath(String v)
    {
        _sPath = v;
    }

    //----------------------------------------------------------------
    // TAG open
    //----------------------------------------------------------------
    public int doStartTag()
    {
        JspWriter out = pageContext.getOut();
        if (_sPath != null)
        {
            println(out, "<!-- [include]  ( path = '" + _sPath + "' ) -->");
            //--- INCLUDE
            include(_sPath);
        }
        else
        {
            tagLibError("INCLUDE : No attribute 'path' !");
        }
        return (SKIP_BODY);
    }
    //---------------------------------------------------------------
}