package org.objectweb.telosys.uil.taglib.util;

import javax.servlet.http.HttpServletResponse;

import org.objectweb.telosys.uil.taglib.CommonTagSupport;

/**
 * @author Laurent GUERIN
 * 
 */
public class NoCache extends CommonTagSupport
{
    //----------------------------------------------------------------
    // Just set the HTTP Headers to avoid browser caching
    //----------------------------------------------------------------
    public int doStartTag()
    {
        HttpServletResponse response = (HttpServletResponse) pageContext.getResponse();
        
        response.setHeader ("Pragma", "no-cache"); //HTTP 1.0
        
        response.setHeader ("Cache-Control", "no-cache"); //HTTP 1.1
        // response.setHeader("Cache-Control","no-store"); 
        // "no-store" is alse used sometimes, but "no-cache" is the more polite keyword
        
        response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
        
        return (SKIP_BODY);
    }
    //----------------------------------------------------------------
}