package org.objectweb.telosys.uil.taglib.widget;


/**
 * Declarative interface for tags considered as "items container" : <br>
 * combobox, listbox, radiogroup 
 * @author Laurent GUERIN
 *
 */
public interface ItemsContainer
{
    /**
     * Each ItemsContainer tag must be able to provide its current value
     * @return
     */
    public String getValue();
}
