package org.objectweb.telosys.uil.taglib.widget;

import org.objectweb.telosys.uil.taglib.widget.html.ListHeadHTML;


/**
 * @author Laurent GUERIN
 *  
 */
public class ListHead extends GenericTag
{
    protected static final String TAG_NAME = "listhead";

    //----------------------------------------------------------------
    // TAG generators ( thread safe => static )
    //----------------------------------------------------------------
    private final static IWidget  $htmlGen = new ListHeadHTML();

    private final static IWidget  $xulGen  = null;

    //----------------------------------------------------------------
    // TAG attributes
    //----------------------------------------------------------------

    /**
     * Constructor
     */
    public ListHead()
    {
        super(TAG_NAME, $htmlGen, $xulGen);
    }

    //----------------------------------------------------------------
    //----------------------------------------------------------------
//    public List getParentList()
//    {
//        Tag parentTag = getParent();
//        if (parentTag != null)
//        {
//                if ( parentTag instanceof ListHead )
//                {
//                    parentTag = parentTag.getParent();
//                    if ( parentTag instanceof List )
//                    {
//                        return (List) parentTag;
//                    }
//                }
//        }
//        return null;
//    }
    
    //----------------------------------------------------------------
    //----------------------------------------------------------------
    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    public int doStartTag()
    {
//        applyDefaults();
//        Page.initTabIndex(pageContext);
        startTag();
        return (EVAL_BODY_INCLUDE);
    }

    //----------------------------------------------------------------
    /*
     * (non-Javadoc)
     * 
     * @see javax.servlet.jsp.tagext.Tag#doEndTag()
     */
    public int doEndTag()
    {
        endTag();
//        reset();
        return (EVAL_PAGE); //  EVAL_PAGE = continue , SKIP_PAGE = abort the processing
    }
}
