package org.objectweb.telosys.uil.taglib.widget.html;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericItemsListTag;

/**
 * HTML generation for items list
 * 
 * @author Laurent GUERIN
 *  
 */
public class GenericItemsListHTML extends GenericHTML // Doesn't implement IWidget 
{
    //----------------------------------------------------------------
    public void printItem(JspWriter out, GenericItemsListTag tag, int iRow, String sVal, String sTxt, String sTitle, boolean bSelected) throws IOException
    {
        out.print("<option " );
        out.print( getIdAttr(tag, iRow)+ " " ); // id="tagID_iRow"
        out.print( getClassAttr(tag)+ " " );
        out.print( getStyleAttrWithoutPosition(tag)+ " " );
        out.print("value=\"" + sVal + "\" ");
        if ( sTitle != null )
        {
            out.print("title=\"" + sTitle + "\" ");
        }
        if ( bSelected ) 
        {
            out.print(" selected=\"selected\" ");            
        }
        
        out.println(">" + sTxt + "</option>");
    }
}