package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.ComboBox;
import org.objectweb.telosys.uil.taglib.widget.GenericTag;
import org.objectweb.telosys.uil.taglib.widget.IWidget;

/**
 * XUL imlementation for ComboBox widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class ComboBoxXUL extends GenericXUL implements IWidget 
{
    //----------------------------------------------------------------
    public void startTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        ComboBox tag = (ComboBox) genericTag ;
        
        //--- Generation du tag <stack ... ><menulist ... ><menupopup> [<menuitem>] </menupopup></menulist></stack>
        out.print("<stack ");
        //out.print(" style=\"" + TagCommons.styleXYHW(_sX, _sY, null, null, pageContext) + "\"");

        out.print("><menulist><menupopup  ");

        //--- Ajout des attributs communs
        //printCommonsAttributes(out);
        out.print(" >");
    }

    public void endTag(JspWriter out, GenericTag genericTag) throws IOException
    {
        //Ferrmeture des tags
        out.print("</menupopup></menulist></stack>");
    }

    //----------------------------------------------------------------

    //    private void printCommonsAttributes(JspWriter out) throws IOException
    //    {
    //        //Recuperation des valeurs communes
    //        String sClass = getAttributeValue(TAG_NAME, "class", _sClass );
    //      
    //        out.print( " id=\"" + getId() + "\"" ); //Nom qui permettra de grouper les <option>
    //
    //        
    //        if ( sClass != null )
    //            out.print( " class=\"" + sClass + "\"" );
    //        
    //        
    //    }

}