package org.objectweb.telosys.uil.taglib.widget.xul;

import java.io.IOException;

import javax.servlet.jsp.JspWriter;

import org.objectweb.telosys.uil.taglib.widget.GenericItemsListTag;

/**
 * XUL imlementation for ComboItems widget
 * 
 * @author Laurent GUERIN
 *  
 */
public class GenericItemsListXUL extends GenericXUL // Doesn't implement IWidget 
{
    //----------------------------------------------------------------
    public void printItem(JspWriter out, GenericItemsListTag tag, int iRow, String sVal, String sTxt, boolean bSelected) throws IOException
    {
        out.print("<option " );
        out.print( getIdAttr(tag, iRow)+ " " ); // id="tagID_iRow"
        // TODO
        //out.print( getClassAttr(tag)+ " " );
        //out.print( getStyleAttr(tag)+ " " );
        out.print("value=\"" + sVal + "\" ");
        
        if ( bSelected ) 
        {
            out.print(" selected=\"selected\" ");            
        }
        
        out.println(">" + sTxt + "</option>");
    }
}